/*
 *  edit_mode.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 11/4/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

#include "jointed_rigidbody_contact.h"

void NeighboringPlankSensitivity
(unsigned int irb, 
 CDesignSensitivity& desSens,
 const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir);

void GetDesignSensitivity
(CDesignSensitivity& desSens,                    
 const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir,                
 unsigned int irb0,
 unsigned int imode,  // trans:0,1,2 rot:3,4,5, len:6,7
 unsigned int icont_config, // 0-8
 const CContactProp& contProp);

bool IsAliveMode
(const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir,                
 unsigned int irb0,
 unsigned int imode, // trans:0,1,2 rot:3,4,5, len:6,7
 unsigned int icont_flg, // 0-8
 unsigned int ijnt_flg);

void DrawRigidBody_Ini_Mode
(unsigned int irb,
 const std::vector<CRigid3D_Ini>& aRI,                         
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir, 
 const CContactPoints_RigidBody3D& aCP,
 int imode_edit,
 double hvh);  // -1 none,

void DrawRigidBody_Ini_BoundMode
(unsigned int irb,
 const std::vector<CRigid3D_Ini>& aRI,                         
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir, 
 const CContactPoints_RigidBody3D& aCP,
 int imode_edit,
 double tr,
 double tmode, double tmin, double tmax,
 double hvh, 
 bool is_range_ok);  // -1 none,  

void DrawRigidBody_Ini_ModeDist
(unsigned int irb,
 const std::vector<CRigid3D_Ini>& aRI,                         
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir, 
 const CContactPoints_RigidBody3D& aCP,
 int imode_edit,
 double tr,
 double tmode, 
 double hvh);  // -1 none,  

int PickRigidBodyEditMode
(const Com::CVector3D& src, const Com::CVector3D& dir,
 const std::vector<CRigid3D_Ini>& aRI,
 const CContactPoints_RigidBody3D& aCP,
 unsigned int irb,
 const std::vector<CJoint_Fix>& aFix,       
 const std::vector< std::pair<unsigned int,unsigned int> >& aFixDir,  
 PARAM_TYPE itype,
 double hvh);

