/*
 *  gl_drawer_furniture.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 10/31/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

#if !defined(GL_DRAWER_FURNITURE_H)
#define GL_DRAWER_FURNITURE_H

#include "nail_bound_furniture.h"
#include "jointed_rigidbody_contact.h"

void DrawExternalForce
(const CRigid3D_Ini& ri,
 const CRigid3D_Def& rd,
 const CExternalForceOnRigidBody& ef,
 bool is_current, 
 const Com::CVector3D& zscr);

void DrawContactForce
(const CRigid3D_Ini& ri,
 const CRigid3D_Def& rd,
 const CContactPoints_RigidBody3D& aCP,
 const CContactProp& contProp);

void DrawRigidBody_Ini
(const CRigid3D_Ini& ri,                 
 const float* color);
// double r, double g, double b, double a);
// unsigned int imode);  // mode 0:normal, mode 1:hilight, mode 2:gohst

void DrawRigidBody_Def
(const CRigid3D_Ini& ri, 
 const CRigid3D_Def& rd,   
 const float* color);
// double r, double g, double b, double a);
// unsigned int imode);


void DrawNails
(const CJoint_Fix& cjs, 
 unsigned int idir0, unsigned int idir1,
 const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CRigid3D_Def>& aRD,                
 bool is_current,
 const CNailJoint& nj, 
 bool isnt_brake);

void DrawNails
(unsigned int idir0, unsigned int idir1,
 const CRigid3D_Ini& ri0, const CRigid3D_Def& rd0, 
 const CRigid3D_Ini& ri1, const CRigid3D_Def& rd1, 
 bool is_current,
 const CNailJoint& nj,
 bool isnt_brake);  // nail is go through rb1 to rb0 

void DrawFixJoint
(bool is_initial, bool is_selscted, 
 const CJoint_Fix& cjs, 
 const CJoint_Fix_Force& jff,
 const std::vector<CRigid3D_Ini>& aRI,
 const std::vector<CRigid3D_Def>& aRD);

void DrawFloor
(const CContactProp& contProp,
 float r, float g, float b);


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int PickBox_Ini
(const Com::CVector3D& src, const Com::CVector3D& dir, 
 Com::CVector3D& hitpos,
 unsigned int& iface,
 ////
 const std::vector<CRigid3D_Ini>& aRI);

#endif
