/*
 *  joint_connectivity.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 9/25/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

#if !defined(JOINT_CONNECTIVITY_H)
#define JOINT_CONNECTIVITY_H

#include "joint_fix.h"
#include "furniture_utility.h"
#include "rigid_contact.h"

// no contact information here

double JointConnectivityEnergy
(const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CJoint_Fix>& aFix, 
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir);

double GetSensitivityJCE_InitialConfigBox
(std::vector<std::pair<Com::CVector3D,Com::CVector3D> >& aSens_BoxPosRot,
 std::vector<Com::CVector3D>& aSens_BoxLen,
 std::vector<Com::CVector3D>& aSens_JntPos,
 ////
 const std::vector<CRigid3D_Ini>& aRI, 
 const std::vector<CJoint_Fix>& aFix, 
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir);

void TestSensitive_JointConnectivityEnergy();

void EnforceJointConnectivity_ChangeBoxLen
(std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CJoint_Fix>& aFix, 
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 bool is_rb0_len_chenge=true);

void EnforceJointConnectivity_ChangeBoxPosRotLen
(std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CJoint_Fix>& aFix, 
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir );

bool GetIntersectionOfTwoPlanks(Com::CVector3D& a, Com::CVector3D& b,
                                const CRigid3D_Ini& ri0, const CRigid3D_Ini& ri1,
                                unsigned int idir0, unsigned int idir1);


#endif