/*
 *  jointed_rigidbody_contact_test.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 10/24/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

#if !defined(JOINTED_RIGID_BODY_CONTACT_TEST_H)
#define JOINTED_RIGID_BODY_CONTACT_TEST_H

#include "delfem/vector3d.h"
#include "delfem/matvec/matdia_blkcrs.h"
#include "delfem/matvec/vector_blk.h"

#include "rigidbody.h"
#include "joint_fix.h"
#include "rigid_contact.h"
#include "rigid_contact_ls.h"
#include "jointed_rigidbody_contact.h"

void TestSensitivePRLM_InitialConfigBox_JointedRigidBodyContactSystem
(PARAM_TYPE itype_s, unsigned int irb_s, unsigned int idim_s,
 ANCHOR_RELOCATION_TYPE itype_anchor_reloc,
 ////
 std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,  
 std::vector<CJoint_Fix>& aFix,
 std::vector<CJoint_Fix_Force>& aFixForce,  
 /////
 const std::vector<CExternalForceOnRigidBody>& aExForce,
 const Com::CVector3D& gravity,
 const CContactProp& contProp, 
 std::vector<CContactPoints_RigidBody3D>& aFP);

// position rotation box-length joit-position
void TestSensitivePRLM_InitialConfigBox_JointedRigidBodyContactSystem
(const CDesignSensitivity& desSens,
 ////
 std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,   
 std::vector<CJoint_Fix>& aFix,
 std::vector< std::pair<unsigned int,unsigned int> >& aFixDir, 
 std::vector<CJoint_Fix_Force>& aFixForce, 
 const std::vector<CExternalForceOnRigidBody>& aExForce,
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp, 
 std::vector<CContactPoints_RigidBody3D>& aFP);

void TestSensitiveResidual_JointedRigidBodyContactSystem
(PARAM_TYPE itype_s, unsigned int irb_s, unsigned int idim_s, 
 ANCHOR_RELOCATION_TYPE itype_anchor_reloc,
 ////
 std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,   
 std::vector<CJoint_Fix>& aFix,
 std::vector<CJoint_Fix_Force>& aFixForce,  
 const std::vector<CExternalForceOnRigidBody>& aExForce,
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);

void TestSensitiveResidual_JointedRigidBodyContactSystem
(const CDesignSensitivity& desSens,
 ////
 std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,   
 std::vector<CJoint_Fix>& aFix,
 std::vector<CJoint_Fix_Force>& aFixForce,   
 const std::vector<CExternalForceOnRigidBody>& aExForce,
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp, 
 std::vector<CContactPoints_RigidBody3D>& aCP);

#endif
