
//#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")

#if defined(__VISUALC__)
#pragma warning( disable : 4786 ) 
#endif
#define for if(0);else for

#include <iostream>
#include <vector>
#include <string>
#include <assert.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <cstdlib> //(exit)
#include <deque>

#if defined(__APPLE__) && defined(__MACH__)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

#include "delfem/camera.h"
#include "delfem/drawer_gl_utility.h"
#include "delfem/glut_utility.h"
#include "delfem/ls/solver_ls_iter.h"
#include "delfem/vector2d.h"
#include "delfem/drawer_field.h"

#include "rigid_contact.h"
#include "furniture.h"
#include "rigid_pointset.h"
#include "rigid_contact_test.h"
#include "furniture_optimizer.h"
#include "gl_drawer_furniture.h"
#include "nail_bound_furniture.h"
#include "edit_furniture.h"
#include "edit_mode.h"
#include "optimize_furniture.h"

double mov_begin_x, mov_begin_y;
int imodifier;
bool is_button_pressed;

CJointedRigidBody jrb;
CJointedRigidBody jrb_pre;
bool is_animation = true;
const double dt = 0.02;

int iwin_des;
Com::View::CCamera_2DH camera_des;

int iwin_sim;
Com::View::CCamera_2DH camera_sim;

int iwin_sgg; // window handle
int isgg_hover = -1;
std::vector<CJointedRigidBody> aSggJRB;

std::vector<CDesModeBound> aDesModeBound;
int ipicked_rb = -1;
CDesModeBound desModeBound;
CSimulationSensitivity simSens;

double tmode;

int ind_picked_obj; 
int rigid_edit_mode;

// 0 : no suggestion, no feedback
// 1 : no suggestion, with feedback
// 2 : with suggestion, with feedback
// 4 : with suggestion, with feedback (example shapes)
// 5 : solve dynamics
int imode_userstudy = 4;
bool is_show_feedback = false;

// 0 : normal
// 1 : optimization
// 2 : add plank
// 3 : del plank
// 4 : edit load
// 5 : init
// 6 : undo
unsigned int imode_system = 0;

// mode 2 (add plank) variables
unsigned int nPosAddPlank = 0;
Com::CVector3D pos0_addplank;
Com::CVector3D pos1_addplank;
Com::CVector3D pos2_addplank;
Com::CVector3D n0_addplank, x0_addplank;
// -2 on the floor, -1:initial  
int irb0_addplank = -1; 
int irb2_addplank = -1;
int iface0_addplank;
int iface2_addplank;

int istat_struc=0; // 0:valid  1:disconnect_joint  2:topple  3:joint_collapse

void DrawMenu()
{    
  GLint viewport[4];
	::glGetIntegerv(GL_VIEWPORT,viewport);
  double winh = viewport[3];
  int margin_b = 13;
  int margin_u = 10;  
  void* font = GLUT_BITMAP_HELVETICA_18;
  const double base = 2*margin_b/winh-1;
  const double top = 2*(18+margin_b+margin_u)/winh-1;
  ::glDisable(GL_DEPTH_TEST);
  ::glMatrixMode(GL_PROJECTION);
  ::glPushMatrix();            
  ::glLoadIdentity();    
  ::glMatrixMode(GL_MODELVIEW);
  ::glPushMatrix();                
  ::glLoadIdentity();        
  int win_h = glutGet(GLUT_WINDOW_HEIGHT);    
  unsigned int nmenu = 5;
  double rect_width = 2.0/nmenu;
  if( imode_system == 5 ){ ::glColor3d(1.0,0.6,0.6); }
  else{ ::glColor3d(0.8,0.8,0.8); }
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*0,-1.0);
  ::glVertex2d(-1+rect_width*1,-1.0);
  ::glVertex2d(-1+rect_width*1,top);
  ::glVertex2d(-1+rect_width*0,top);
  ::glEnd();
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*0.1, base, font, "initial");
  ////
  if( imode_system == 6 ){ ::glColor3d(0.6,1.0,0.6); }
  else{ ::glColor3d(0.8,0.8,0.8); }
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*1,-1.0);
  ::glVertex2d(-1+rect_width*2,-1.0);
  ::glVertex2d(-1+rect_width*2,top);
  ::glVertex2d(-1+rect_width*1,top);
  ::glEnd();    
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*1.1, base, font, "undo");  
  ////
  if( imode_system == 2 ){ ::glColor3d(0.6,0.6,1.0); }
  else{ ::glColor3d(0.8,0.8,0.8); }
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*2,-1.0);
  ::glVertex2d(-1+rect_width*3,-1.0);
  ::glVertex2d(-1+rect_width*3,top);
  ::glVertex2d(-1+rect_width*2,top);
  ::glEnd();    
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*2.1, base, font, "add");  
  ////
  if( imode_system == 3 ){ ::glColor3d(1.0,0.6,1.0); }
  else{ ::glColor3d(0.8,0.8,0.8); }
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*3,-1.0);
  ::glVertex2d(-1+rect_width*4,-1.0);
  ::glVertex2d(-1+rect_width*4,top);
  ::glVertex2d(-1+rect_width*3,top);
  ::glEnd();        
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*3.1, base, font, "delete");  
  ////
  if( imode_system == 4 ){ ::glColor3d(0.6,1.0,1.0); }
  else{ ::glColor3d(0.8,0.8,0.8); }
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*4,-1.0);
  ::glVertex2d(-1+rect_width*5,-1.0);
  ::glVertex2d(-1+rect_width*5,top);
  ::glVertex2d(-1+rect_width*4,top);
  ::glEnd();        
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*4.1, base, font, "weight");  
  ////
  /*
  bool is_stable = true; 
  if( istat_struc != 0 ){ ::glColor3d(1.0,1.0,0.6); }
  else{ 
   */
  /*
  ::glColor3d(0.8,0.8,0.8); 
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*5,-1.0);
  ::glVertex2d(-1+rect_width*6,-1.0);
  ::glVertex2d(-1+rect_width*6,-0.8);
  ::glVertex2d(-1+rect_width*5,-0.8);
  ::glEnd();        
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*5.1, -0.9, font, "sugg");    
   */
  ////
  ::glEnable(GL_BLEND);  
  ::glLineWidth(2);
  ::glColor3d(0,0,0);
  ::glBegin(GL_LINES);
  for(unsigned int imenu=0;imenu<nmenu-1;imenu++){
    ::glVertex3d(-1+rect_width*(imenu+1),-1.0,-0.2);
    ::glVertex3d(-1+rect_width*(imenu+1),top,-0.2);
  }
  ::glEnd();      
  ////
  {
    double mass = 0;
    for(unsigned int ifix=0;ifix<jrb.aExForce.size();ifix++){      
      mass += Dot(jrb.gravity,jrb.aExForce[ifix].force);
    }
    mass *= 0.01;
    char str[256];
    sprintf(str,"%.0lfkg",mass);
    RenderBitmapString(-1.0+rect_width*0.1, -0.8, font,str);        
  }
  
  ::glMatrixMode(GL_PROJECTION);
  ::glPopMatrix();            
  ::glMatrixMode(GL_MODELVIEW);    
  ::glPopMatrix();    
  ::glEnable(GL_LIGHTING);    
  ::glEnable(GL_DEPTH_TEST);
  //    std::cout << "disp_des1" << std::endl;    
  bool is_lighting = glIsEnabled(GL_LIGHTING);
}

bool PickMenu(double mov_begin_x, double mov_begin_y, int state)
{  
  unsigned int nmenu = 5;
  double rect_width = 2.0/nmenu;
  if( mov_begin_y < -0.8 ){
    if(      mov_begin_x < -1+rect_width*1 ){ // init
      if( state == GLUT_DOWN ){
        jrb_pre = jrb;
        jrb.Clear();
        imode_system = 5;
      }
      else{ imode_system = 0; rigid_edit_mode = -1; }      
      aDesModeBound.clear();
      aSggJRB.clear();      
    }
    else if( mov_begin_x < -1+rect_width*2 ){ // undo
      if( state == GLUT_DOWN ){
        jrb = jrb_pre;        
        imode_system = 6;
      }
      else{ imode_system = 0; rigid_edit_mode = -1; }
      aDesModeBound.clear();
      aSggJRB.clear();            
    }
    else if( mov_begin_x < -1+rect_width*3 ){ // add
      if( state == GLUT_DOWN ){
        if( imode_system != 2 ){ imode_system = 2; }
        else{ imode_system = 0; rigid_edit_mode = -1; }
      }
      aDesModeBound.clear();
      aSggJRB.clear();      
    }        
    else if( mov_begin_x < -1+rect_width*4 ){ // del
      if( state == GLUT_DOWN ){
        if( imode_system != 3 ){ imode_system = 3; }
        else{ imode_system = 0; rigid_edit_mode = -1; }      
      }
      aDesModeBound.clear();
      aSggJRB.clear();      
    }                
    else if( mov_begin_x < -1+rect_width*5 ){ // weight
      if( state == GLUT_DOWN ){      
        if( imode_system != 4 ){ imode_system = 4; }
        else{ imode_system = 0; rigid_edit_mode = -1; }
      }
      aDesModeBound.clear();
      aSggJRB.clear();      
    }                    
    /*
    else if( mov_begin_x < -1+rect_width*6 ){ // sugg
      if( state == GLUT_DOWN ){      
        GetSuggestionModes
        (aDesModeBound,
         jrb.aRI, jrb.aRD, 
         jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
         ////
         jrb.gravity, jrb.contProp, jrb.aFP);  
        aSggJRB.resize(aDesModeBound.size()+1,jrb);
        MakeSuggestionSupportMaterial2(aSggJRB[aDesModeBound.size()]);        
      }
    } 
     */
    return true;
  }
  return false;
}



void DrawFileMenu()
{    
  GLint viewport[4];
	::glGetIntegerv(GL_VIEWPORT,viewport);
  double winh = viewport[3];
  int margin_b = 13;
  int margin_u = 10;  
  void* font = GLUT_BITMAP_HELVETICA_18;
  const double bottom = 1-2*(18+margin_b+margin_u)/winh;
  const double base = bottom+2*margin_b/winh;  
  
  ::glDisable(GL_DEPTH_TEST);
  ::glDisable(GL_LIGHTING);
  ::glDisable(GL_BLEND);
  ::glMatrixMode(GL_PROJECTION);
  ::glPushMatrix();            
  ::glLoadIdentity();    
  ::glMatrixMode(GL_MODELVIEW);
  ::glPushMatrix();                
  ::glLoadIdentity();        
  int win_h = glutGet(GLUT_WINDOW_HEIGHT);    
  unsigned int nmenu = 4;
  double rect_width = 2.0/nmenu;
  ::glColor3d(0.8,0.8,0.8);
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*0,bottom);
  ::glVertex2d(-1+rect_width*1,bottom);
  ::glVertex2d(-1+rect_width*1,+1.0);  
  ::glVertex2d(-1+rect_width*0,+1.0);
  ::glEnd();
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*0.1, base, font, "simple");
  ////
  ::glColor3d(0.8,0.8,0.8);
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*1,bottom);
  ::glVertex2d(-1+rect_width*2,bottom);
  ::glVertex2d(-1+rect_width*2,+1.0);  
  ::glVertex2d(-1+rect_width*1,+1.0);
  ::glEnd();    
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*1.1, base, font, "chair");  
  ////
  ::glColor3d(0.8,0.8,0.8);
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*2,bottom);  
  ::glVertex2d(-1+rect_width*3,bottom);  
  ::glVertex2d(-1+rect_width*3,+1.0);  
  ::glVertex2d(-1+rect_width*2,+1.0);
  ::glEnd();    
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*2.1, base, font, "table");  
  ////
  ::glColor3d(0.8,0.8,0.8);
  ::glBegin(GL_QUADS);
  ::glVertex2d(-1+rect_width*3,bottom);  
  ::glVertex2d(-1+rect_width*4,bottom);  
  ::glVertex2d(-1+rect_width*4,+1.0);  
  ::glVertex2d(-1+rect_width*3,+1.0);
  ::glEnd();        
  ::glColor3d(0,0,0);    
  RenderBitmapString(-1+rect_width*3.1, base, font, "weird");  
  ////  
  ::glEnable(GL_BLEND);  
  ::glLineWidth(2);
  ::glColor3d(0,0,0);
  ::glBegin(GL_LINES);
  for(unsigned int imenu=0;imenu<nmenu-1;imenu++){
    ::glVertex3d(-1+rect_width*(imenu+1),+1.0,-0.2);
    ::glVertex3d(-1+rect_width*(imenu+1),bottom,-0.2);
  }
  ::glEnd();      
  
  ::glMatrixMode(GL_PROJECTION);
  ::glPopMatrix();            
  ::glMatrixMode(GL_MODELVIEW);    
  ::glPopMatrix();    
  ::glEnable(GL_LIGHTING);    
  ::glEnable(GL_DEPTH_TEST);
  //    std::cout << "disp_des1" << std::endl;    
  bool is_lighting = glIsEnabled(GL_LIGHTING);
}

bool PickFileMenu(double mov_begin_x, double mov_begin_y, int state)
{  
  unsigned int nmenu = 4;
  double rect_width = 2.0/nmenu;
  std::string str;
  if( mov_begin_y > +0.8 ){
    if(      mov_begin_x < -1+rect_width*1 ){ // init
      std::cout << "simple" << std::endl;
      str = "example1.dat";
    }
    else if( mov_begin_x < -1+rect_width*2 ){ // undo
      std::cout << "hoge2" << std::endl;      
      str = "example2.dat";      
    }
    else if( mov_begin_x < -1+rect_width*3 ){ // add
      std::cout << "chair" << std::endl;
      str = "example3.dat";            
    }        
    else if( mov_begin_x < -1+rect_width*4 ){ // del
      std::cout << "weird" << std::endl;            
//      str = "example4.dat";      
      str = "shelf2.dat";            
    }           
    {
      bool res = jrb.loadFile(str);
      if( !res ) return true;
      isgg_hover = -1;
      aSggJRB.clear();
      aDesModeBound.clear();
      if( jrb.aRI.size() == 0 ){
        Com::CBoundingBox3D bb(-0.3,0.3, -0.3,0.3, -0.3,0.3);
        camera_des.Fit(bb);
      }
      else{
        camera_des.Fit(jrb.GetBoundingBox(false));    
      }
      ::glutSetWindow(iwin_des);  
      ::glMatrixMode(GL_PROJECTION);
      ::glLoadIdentity();
      Com::View::SetProjectionTransform(camera_des);      
    }    
    return true;
  }
  return false;
}




void myGlutResize(int w, int h)
{
  if( glutGetWindow() == iwin_des ){
    camera_des.SetWindowAspect((double)w/h);
    glViewport(0, 0, w, h);
    ::glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    Com::View::SetProjectionTransform(camera_des);
  }
  else if( glutGetWindow() == iwin_sim ){
    camera_sim.SetWindowAspect((double)w/h);
    glViewport(0, 0, w, h);
    ::glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    Com::View::SetProjectionTransform(camera_sim);    
  }
	glutPostRedisplay();
}

void myGlVertex3d(const Com::CVector3D& pos){
  ::glVertex3d(pos.x, pos.y, pos.z);
}


unsigned int m_texWidth, m_texHeight;
unsigned int m_texName = 0;


void DrawModeDist
(const CJointedRigidBody& sgg, const CDesModeBound& dmb,
 double tmod,double hvh)
{
  if( dmb.irb0 >=0 && dmb.irb0 < sgg.aRI.size() ){
    unsigned int irb0 = dmb.irb0;
    DrawRigidBody_Ini_ModeDist(irb0,sgg.aRI,sgg.aFix,sgg.aFixDir,sgg.aFP[irb0],dmb.imode0,
                               dmb.r0,tmod,hvh);
    if( dmb.irb1 >=0 && dmb.irb1 < sgg.aRI.size() ){
      unsigned int irb1 = dmb.irb1;
      DrawRigidBody_Ini_ModeDist(irb1,sgg.aRI,sgg.aFix,sgg.aFixDir,sgg.aFP[irb1],dmb.imode1,
                                 dmb.r1,tmod,hvh);  
      if( dmb.irb2 >=0 && dmb.irb2 < sgg.aRI.size() ){
        unsigned int irb2 = dmb.irb2;
        DrawRigidBody_Ini_ModeDist(irb2,sgg.aRI,sgg.aFix,sgg.aFixDir,sgg.aFP[irb2],dmb.imode2,
                                   dmb.r2,tmod,hvh);          
      }            
    }
  }
}

void PackedSugImages(unsigned int nsgg, double aspf, 
                     int win_w, int win_h, 
                     int& swin_w, int& swin_h,
                     unsigned int& nclm)
{
  double aspw = (double)win_w/win_h;
//  unsigned int nsgg = aSggJRB.size();
  //    std::cout << aspf << " " << aspw << " " << nsgg << std::endl;
//  unsigned int nclm;
  for(nclm=1;nclm<nsgg;nclm++){
    unsigned int nrow = nsgg/nclm;
    if( nsgg%nclm != 0 ) nrow++; 
    if( aspw*nrow <= nclm*aspf ) break;
  }
  if( nclm == 1 && aspf < aspw ){ nclm = 0; }
  unsigned int nrow;
  for(nrow=1;nrow<nsgg;nrow++){
    unsigned int nclm = nsgg/nrow;
    if( nsgg%nrow != 0 ) nclm++; 
    if( aspf*nclm <= nrow*aspw ) break;
  }          
  if( nrow == 1 && aspf > aspw ){ nrow = 0; }
//  int swin_w, swin_h;
  if( nclm > 0 && nrow > 0 ){
    if( (double)win_w/nclm > (double)win_h/nrow*aspf ){
      swin_w = win_w/nclm;
      swin_h = swin_w/aspf;
    }
    else{
      swin_w = win_h/nrow*aspf;
      swin_h = win_h/nrow;
      nclm = nsgg/nrow;
      if( nsgg%nrow != 0 ) nclm++;
    }      
  }
  else if( nclm > 0 ){
    swin_w = win_w/nclm;
    swin_h = swin_w/aspf;      
  }
  else if( nrow >0 ){
    swin_w = win_h/nrow*aspf;
    swin_h = win_h/nrow;
    nclm = nsgg/nrow;
    if( nsgg%nrow != 0 ) nclm++;      
  }
  else{
    swin_w = win_w;
    swin_h = swin_w/aspf;      
  }  
}


void myGlutDisplay(void)
{
//  std::cout << desModeBound.irb0 << " " << desModeBound.irb1 << " " << desModeBound.tmin << " " << desModeBound.tmax << std::endl;
//	::glClearColor(0.2f, .7f, 0.7f, 1.0f);
  GLfloat color_red[4] = { 1.0f, 0.6f, 0.6f, 0.9f };

	::glClearColor(1.0f, 1.0f, 1.0f, 1.0f);  
	::glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	::glEnable(GL_DEPTH_TEST);
  ::glEnable(GL_LIGHTING);
  
	::glEnable(GL_POLYGON_OFFSET_FILL );
	::glPolygonOffset( 1.1f, 4.0f );
  
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity();
    
  if( glutGetWindow() == iwin_des ){    
//    std::cout << "disp_des" << std::endl;    
    const Com::CVector3D& zscr = camera_des.GetRotMatrix3().MatVecTrans( Com::CVector3D(0,0,1) );
    Com::View::SetModelViewTransform(camera_des);    
    ShowBackGround();    
    if( imode_system == 2 && nPosAddPlank == 2 ){
      if( Dot(pos2_addplank-jrb.contProp.cont_base,jrb.contProp.cont_norm) < 0 ){
        DrawFloor(jrb.contProp, 0.8,0.6,0.6);      
      }
      else{
        DrawFloor(jrb.contProp, 0.6,0.8,0.6);              
      }
    }
    else{
      DrawFloor(jrb.contProp, 0.6,0.8,0.6);      
    }
    if( isgg_hover >= 0 && isgg_hover < aSggJRB.size() ){ 
      {
        std::vector<unsigned int> aIndRBPicked;
        const CJointedRigidBody& sgg = aSggJRB[isgg_hover];
        if( isgg_hover < aDesModeBound.size() ){
          const CDesModeBound& dmb = aDesModeBound[isgg_hover];
          if( dmb.irb0 >= 0 && dmb.irb0 < sgg.aRI.size() ){ 
            aIndRBPicked.push_back(dmb.irb0); 
            if( dmb.irb1 >= 0 && dmb.irb1 < sgg.aRI.size() ){ 
              aIndRBPicked.push_back(dmb.irb1); 
              if( dmb.irb2 >= 0 && dmb.irb2 < sgg.aRI.size() ){ aIndRBPicked.push_back(dmb.irb2); }
            }
          }
        }
        else{
          for(unsigned int irb=jrb.aRI.size();irb<sgg.aRI.size();irb++){
            aIndRBPicked.push_back(irb);
          }
        }        
        GLfloat color_blue[4] = { 0.7f, 0.7f, 1.0f, 0.9f };        
        aSggJRB[isgg_hover].Draw(false, aIndRBPicked, color_blue,zscr);      
      }
      if( isgg_hover < aDesModeBound.size() ){
        double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();        
        CJointedRigidBody& sgg = aSggJRB[isgg_hover];   
        const CDesModeBound& dmb = aDesModeBound[isgg_hover];
        double tmin = dmb.tmin;
        double tmax = dmb.tmax;                
        double tmod = (tmin+tmax)*0.5;
        DrawModeDist(sgg,dmb,tmod,hvh);
      }
    }
    else{
      if( imode_system == 0 ){
        if( imode_userstudy == 0 ){
          if( ind_picked_obj >= 0 && ind_picked_obj<jrb.aRI.size() ){
            double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
            const unsigned int irb = ind_picked_obj;
            DrawRigidBody_Ini_Mode(irb,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb],
                                   rigid_edit_mode,hvh);                      
          }
        }
        else if( ind_picked_obj >= 0 && ind_picked_obj<jrb.aRI.size() ){
          if( is_button_pressed && rigid_edit_mode >= 0 && ind_picked_obj == desModeBound.irb0 ){
            double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
            const unsigned int irb = ind_picked_obj;
            DrawRigidBody_Ini_BoundMode(irb,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb],
                                        rigid_edit_mode,
                                        1,tmode,desModeBound.tmin,desModeBound.tmax,hvh,
                                        istat_struc ==0 );     
          }          
          else{
            double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
            const unsigned int irb = ind_picked_obj;
            DrawRigidBody_Ini_Mode(irb,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb],
                                   rigid_edit_mode,hvh);            
          }          
        }
        else if( desModeBound.irb0 >= 0 ){
          const CDesModeBound& dmb = desModeBound;
          double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
          if( dmb.irb0 >=0 && dmb.irb0 < jrb.aRI.size() ){
            unsigned int irb0 = dmb.irb0;
            DrawRigidBody_Ini_BoundMode(irb0,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb0],
                                        dmb.imode0,
                                        dmb.r0,tmode,desModeBound.tmin,desModeBound.tmax,hvh,                                        
                                        istat_struc ==0 );                                      
            if( dmb.irb1 >=0 && dmb.irb1 < jrb.aRI.size() ){
              unsigned int irb1 = dmb.irb1;
              DrawRigidBody_Ini_BoundMode(irb1,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb1],
                                          dmb.imode1,
                                          dmb.r1,tmode,desModeBound.tmin,desModeBound.tmax,hvh,                                          
                                          istat_struc ==0 );
              if( dmb.irb2 >=0 && dmb.irb2 < jrb.aRI.size() ){
                unsigned int irb2 = dmb.irb2;
                DrawRigidBody_Ini_BoundMode(irb2,jrb.aRI,jrb.aFix,jrb.aFixDir,jrb.aFP[irb2],
                                            dmb.imode2,
                                            dmb.r2,tmode,desModeBound.tmin,desModeBound.tmax,hvh,
                                            istat_struc ==0 );                                                    
              }              
            }
          }                            
        }
        {
          std::vector<unsigned int> aIndRBPicked; aIndRBPicked.push_back(ind_picked_obj);
          const CDesModeBound& dmb = desModeBound;
          if( dmb.irb0 >= 0 && dmb.irb0 < jrb.aRI.size() ){ 
            aIndRBPicked.push_back(dmb.irb0); 
            if( dmb.irb1 >= 0 && dmb.irb1 < jrb.aRI.size() ){ 
              aIndRBPicked.push_back(dmb.irb1); 
              if( dmb.irb2 >= 0 && dmb.irb2 < jrb.aRI.size() ){ 
                aIndRBPicked.push_back(dmb.irb2); 
              }
            } 
          }
          jrb.Draw(false,aIndRBPicked,color_red,zscr);
        }        
      }
      if( imode_system == 1 ){
        std::vector<unsigned int> aIndRBPicked;
        jrb.Draw(false, aIndRBPicked,color_red,zscr);        
      }
      if( imode_system == 2 ){ // add plank
        std::vector<unsigned int> aIndRBPicked; aIndRBPicked.push_back(ind_picked_obj);
        jrb.Draw(false, aIndRBPicked,color_red,zscr);        
      }
      if( imode_system == 3 ){ 
        std::vector<unsigned int> aIndRBPicked; aIndRBPicked.push_back(ind_picked_obj);
        jrb.Draw(false, aIndRBPicked,color_red,zscr);        
      }      
      if( imode_system == 4 ){ 
        {
          std::vector<unsigned int> aIndRBPicked; aIndRBPicked.push_back(ind_picked_obj);
          jrb.Draw(false, aIndRBPicked,color_red,zscr);        
        }
        ::glDisable(GL_LIGHTING);
        for(unsigned int ief=0;ief<jrb.aExForce.size();ief++){
          const CExternalForceOnRigidBody& ef = jrb.aExForce[ief];
          unsigned int iri = ef.irb;          
          const CRigid3D_Ini& ri = jrb.aRI[iri];
          Com::CVector3D p = ri.GetInitialPosition(ef.pos);
          Com::CVector3D ez = ri.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
          const double r = Com::Length(ef.force*0.001);
          Com::CVector3D ex, ey;
          Com::GetVertical2Vector(ez,ex,ey);
          const unsigned int ndiv=32;
          const double rdiv = 2*3.1415/ndiv;
          double dflg = Dot(ez,ef.force) < 0 ? 1 : -1;
          ::glLineWidth(3);
          if( ef.irb == ind_picked_obj && rigid_edit_mode == -3 ){ ::glColor3d(1,0,1); }
          else{ ::glColor3d(0,0,0); }
          ::glBegin(GL_LINE_LOOP);
          for(unsigned int idiv=0;idiv<ndiv;idiv++){                        
            Com::CVector3D q = p + r*ex*sin(rdiv*idiv) + r*ey*cos(rdiv*idiv) + dflg*0.6*ez*ri.zlen; 
            ::glVertex3d(q.x,q.y,q.z);
          }        
          ::glEnd();
          if( ef.irb == ind_picked_obj && rigid_edit_mode == -2 ){ ::glColor3d(1,0,1); }
          else{ ::glColor3d(0,0,0); }          
          /*
          ::glMatrixMode(GL_MODELVIEW);
          ::glPushMatrix();
          ::glTranslated(p.x,p.y,p.z);
          ::glutSolidSphere(0.05, 12,12);
          ::glPopMatrix();
           */
        }
        ::glDisable(GL_DEPTH_TEST);
        ::glColor3d(1,0,0);
        for(unsigned int ief=0;ief<jrb.aExForce.size();ief++){          
          const CExternalForceOnRigidBody& ef = jrb.aExForce[ief];
          unsigned int iri = ef.irb;          
          if( iri == ind_picked_obj ){   
            const CRigid3D_Ini& ri = jrb.aRI[iri];
            Com::CVector3D p = ri.GetInitialPosition(ef.pos);
            double fl = Length(ef.force);
            char str[8]; 
            sprintf(str, "%dkg",(int)(fl*0.1));
            RenderBitmapString(p.x,p.y,p.z, GLUT_BITMAP_HELVETICA_18, str); 
          }
        }            
        ::glEnable(GL_DEPTH_TEST);
        ::glEnable(GL_LIGHTING);
      }
    }
    ::glDisable(GL_BLEND);
    ::glDisable(GL_LIGHTING);
    if( imode_system == 2 ){
      ::glPointSize(5);
      ::glBegin(GL_POINTS);
      if( nPosAddPlank == 1 || nPosAddPlank == 2 || nPosAddPlank == 3 ){
        ::glColor3d(1,0,0);
        ::glVertex3d(pos0_addplank.x, pos0_addplank.y, pos0_addplank.z);
      }
      if( nPosAddPlank == 1 || nPosAddPlank == 2 ){
        ::glColor3d(0,1,0);      
        ::glVertex3d(pos1_addplank.x, pos1_addplank.y, pos1_addplank.z);      
      }
      if( nPosAddPlank == 2 ){
        ::glColor3d(0,0,1);            
        ::glVertex3d(pos2_addplank.x, pos2_addplank.y, pos2_addplank.z);
      }
      ::glEnd();      
      if( nPosAddPlank == 1 || nPosAddPlank == 2 ){
        ::glLineWidth(3);
        ::glColor3d(0,0,0);
        ::glBegin(GL_LINES);
        ::glVertex3d(pos0_addplank.x, pos0_addplank.y, pos0_addplank.z);
        ::glVertex3d(pos1_addplank.x, pos1_addplank.y, pos1_addplank.z);              
        ::glEnd();
      }
      if( nPosAddPlank == 2 ){
        const Com::CVector3D& d1 = pos1_addplank-pos0_addplank;
        const Com::CVector3D& d2 = pos2_addplank-pos1_addplank;
        ::glLineWidth(3);
        ::glColor3d(0,0,0);
        ::glBegin(GL_LINE_LOOP);
        ::myGlVertex3d(pos0_addplank);
        ::myGlVertex3d(pos0_addplank+d1);
        ::myGlVertex3d(pos0_addplank+d1+d2);
        ::myGlVertex3d(pos0_addplank+d2);  
        ::glEnd();                
      }
    }
    
    DrawMenu();            
    if( imode_userstudy == 4 ){
      DrawFileMenu();
    }

    
    // draw human
    /*
    ::glDisable(GL_LIGHTING);
    ::glEnable(GL_TEXTURE_2D);    
    ::glColor3d(1,1,1.0);
    glBegin(GL_QUADS);
		glTexCoord2f(-0.00, +0.00); glVertex3f(-0.0 , +0.0,1);
		glTexCoord2f(+0.99, +0.00); glVertex3f(+1.7 , +0.0,1);
		glTexCoord2f(+0.99, +0.99); glVertex3f(+1.7 , +1.7,1);
		glTexCoord2f(-0.00, +0.99); glVertex3f(-0.0 , +1.7,1);
    glEnd();    
    ::glEnable(GL_LIGHTING);      
    ::glDisable(GL_TEXTURE_2D);            
     */
    
    // draw annotation
    
    /*
    void* font = GLUT_BITMAP_HELVETICA_18;
//    void* font = GLUT_BITMAP_TIMES_ROMAN_24;
    ::glDisable(GL_DEPTH_TEST);
    ::glDisable(GL_LIGHTING);
    ::glMatrixMode(GL_PROJECTION);
    ::glPushMatrix();            
    ::glLoadIdentity();    
    ::glMatrixMode(GL_MODELVIEW);
    ::glPushMatrix();                
    ::glLoadIdentity(); 
    if( istat_struc == 0 ){ ::glColor3d(0,0,0); }
    else{ ::glColor3d(1,0,0); }
    if( istat_struc == 0 ){ RenderBitmapString(-1+0.1, +0.9, font, "structure OK");     }
    if( istat_struc == 1 ){ RenderBitmapString(-1+0.1, +0.9, font, "joint disconnect"); }
    if( istat_struc == 2 ){ RenderBitmapString(-1+0.1, +0.9, font, "topple");           }
    if( istat_struc == 3 ){ RenderBitmapString(-1+0.1, +0.9, font, "joint collapse");   }
    ::glMatrixMode(GL_MODELVIEW);    
    ::glPopMatrix();
    ::glMatrixMode(GL_PROJECTION);
    ::glPopMatrix();
    ::glEnable(GL_LIGHTING);
    ::glEnable(GL_DEPTH_TEST); 
     */
    if( imode_userstudy > 0 || is_show_feedback ){    
      double bottom = +1;
      if( imode_userstudy == 4 ){
        GLint viewport[4];
        ::glGetIntegerv(GL_VIEWPORT,viewport);
        double winh = viewport[3];
        int margin_b = 13;
        int margin_u = 10;  
        const double base = 1-2*margin_b/winh;
        bottom = 1-2*(18+margin_b+margin_u)/winh;        
      }
      ::glDisable(GL_LIGHTING);
      ::glEnable(GL_TEXTURE_2D);    
      ::glDisable(GL_DEPTH_TEST);
      ::glMatrixMode(GL_PROJECTION);
      ::glPushMatrix();            
      ::glLoadIdentity();    
      ::glMatrixMode(GL_MODELVIEW);
      ::glPushMatrix();                
      ::glLoadIdentity();     
      ::glColor3d(1,1,1.0);
      double rw = 1.5;
      double rat = 40.0/256.0;
      unsigned int ih = 0;
      if( isgg_hover >= 0 && isgg_hover < aSggJRB.size() ){
        ih = 4;
      }
      else if( istat_struc == 0 ){ ih = 0; }
      else if( istat_struc == 1 ){ ih = 2; }
      else if( istat_struc == 2 ){ ih = 3; }
      else if( istat_struc == 3 ){ ih = 1; }    
      glBegin(GL_QUADS);
      glTexCoord2f(0.00,+0.99-(ih+1)*rat); glVertex2f(-1.0,    bottom-rw*rat);
      glTexCoord2f(0.99,+0.99-(ih+1)*rat); glVertex2f(-1.0+rw, bottom-rw*rat);
      glTexCoord2f(0.99,+0.99-(ih+0)*rat); glVertex2f(-1.0+rw, bottom);
      glTexCoord2f(0.00,+0.99-(ih+0)*rat); glVertex2f(-1.0,    bottom);    
      /*
       glTexCoord2f(0.00,+0.00); glVertex2f(-1.0,    +1.0-rw);
       glTexCoord2f(0.99,+0.00); glVertex2f(-1.0+rw, +1.0-rw);
       glTexCoord2f(0.99,+0.99); glVertex2f(-1.0+rw, +1.0);
       glTexCoord2f(0.00,+0.99); glVertex2f(-1.0,    +1.0);    
       */
      glEnd();    
      ::glMatrixMode(GL_MODELVIEW);    
      ::glPopMatrix();
      ::glMatrixMode(GL_PROJECTION);
      ::glPopMatrix();    
      ::glEnable(GL_LIGHTING);      
      ::glDisable(GL_TEXTURE_2D);   
      ::glEnable(GL_DEPTH_TEST);          
    }
    ::glEnable(GL_LIGHTING);      
    ::glDisable(GL_TEXTURE_2D);   
    ::glEnable(GL_DEPTH_TEST);              
    
    if( istat_struc == 2 && isgg_hover == -1 && imode_userstudy >= 2 ){
//      ::glDisable(GL_DEPTH_TEST);
      ::glDisable(GL_LIGHTING);
      double mass = 0;
      Com::CVector3D cg0;
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        double m = jrb.aRI[irb].GetMass();
        mass += m;
        cg0 += m*jrb.aRI[irb].GetIniPosCG();
      }
      cg0 /= mass;
      const Com::CVector3D n = jrb.contProp.cont_norm;
      Com::CVector3D torq(0,0,0);
      unsigned int nCP = 0;
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        const CRigid3D_Ini& ri = jrb.aRI[irb];
        const CRigid3D_Def& rd = jrb.aRD[irb];
        const CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
        for(unsigned int i=0;i<aCP.Size();i++){
          if( !aCP.aFP[i].is_force_cont ) continue;
          nCP++;
          Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);  
          Com::CVector3D v1 = GetCurrentPosition(v0,ri,rd);
          const double depth1 = Com::Dot(n,jrb.contProp.cont_base-v1); 
          torq += Cross(v1-cg0,depth1*n);
        }
      }
      if( nCP > 3 ){
        //      std::cout << "torq " << torq << std::endl;
        torq.SetNormalizedVector();
        Com::CVector3D h = Cross(torq,n);
        const double hcg = Com::Dot(n,jrb.contProp.cont_base-cg0);      
        ::glColor3d(1,0,0);
        ::glBegin(GL_QUADS);      
        double ndiv = 32;
        double rdiv = 0.5*3.14/ndiv;
        double rad = hcg*1.8;
        Com::CVector3D width = torq*hcg*0.2;
        for(unsigned int i=0;i<ndiv;i++){  
          Com::CVector3D a0 = cg0 + rad*sin(rdiv*(i+0))*h - rad*cos(rdiv*(i+0))*n;
          Com::CVector3D a1 = cg0 + rad*sin(rdiv*(i+1))*h - rad*cos(rdiv*(i+1))*n; 
          Com::CVector3D b0 = a0-width;
          Com::CVector3D b1 = a0+width;
          Com::CVector3D b2 = a1+width;
          Com::CVector3D b3 = a1-width;                
          ::glVertex3d(b0.x,b0.y,b0.z);
          ::glVertex3d(b1.x,b1.y,b1.z);
          ::glVertex3d(b2.x,b2.y,b2.z);
          ::glVertex3d(b3.x,b3.y,b3.z);         
        }
        ::glEnd();
        ::glBegin(GL_TRIANGLES);
        {
          Com::CVector3D a0 = cg0 + rad*sin(rdiv*ndiv+0.0)*h - rad*cos(rdiv*ndiv+0.0)*n;
          Com::CVector3D a1 = cg0 + rad*sin(rdiv*ndiv+0.5)*h - rad*cos(rdiv*ndiv+0.5)*n; 
          Com::CVector3D b0 = a0-width*2;
          Com::CVector3D b1 = a0+width*2;
          ::glVertex3d(b0.x,b0.y,b0.z);
          ::glVertex3d(b1.x,b1.y,b1.z);
          ::glVertex3d(a1.x,a1.y,a1.z);        
        }
        ::glEnd();
      }      
      ::glEnable(GL_LIGHTING);
      ::glEnable(GL_DEPTH_TEST);       
    }
  }  
  else if( glutGetWindow() == iwin_sim ){
    const Com::CVector3D& zscr = camera_sim.GetRotMatrix3().MatVecTrans( Com::CVector3D(0,0,1) );
    Com::View::SetModelViewTransform(camera_sim); 
    ShowBackGround();        
    DrawFloor(jrb.contProp,0.6,0.8,0.6);      
    {
      std::vector<unsigned int> aIndRBPicked; aIndRBPicked.push_back(ind_picked_obj);
      jrb.Draw(true, aIndRBPicked,color_red,zscr);        
    }
    ShowFPS();
  }
  else if( glutGetWindow() == iwin_sgg ){    
    const Com::CVector3D& zscr = camera_des.GetRotMatrix3().MatVecTrans( Com::CVector3D(0,0,1) );    
    double aspf = camera_des.GetWindowAspect();
    int win_w = glutGet(GLUT_WINDOW_WIDTH);
    int win_h = glutGet(GLUT_WINDOW_HEIGHT);    
    int swin_w, swin_h;
    unsigned int nclm;    
    unsigned int nsgg = aSggJRB.size();    
    PackedSugImages(nsgg, aspf, win_w, win_h, swin_w, swin_h, nclm);
    double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();    
    for(unsigned int isgg=0;isgg<nsgg;isgg++){
      unsigned int irw = isgg/nclm;
      unsigned int icl = isgg-nclm*irw; 
      ::glViewport(icl*swin_w,win_h-(irw+1)*swin_h,swin_w,swin_h);
//      Com::View::SetModelViewTransform(camera_des);
//      std::cout << isgg << " " << win_w << " " << win_h << " " << irw*swin_w << " " << icl*swin_h << " " << swin_w << " " << swin_h << std::endl;
      ::glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      Com::View::SetProjectionTransform(camera_des);      
      ::glMatrixMode(GL_MODELVIEW);
      ::glLoadIdentity(); 
      Com::View::SetModelViewTransform(camera_des);
      ShowBackGround();          
      DrawFloor(jrb.contProp, 0.6,0.8,0.6);      
//      double time = clock()/1000;
      if( isgg < aDesModeBound.size() ){
        double tmin = aDesModeBound[isgg].tmin;
        double tmax = aDesModeBound[isgg].tmax;
//        double tmod = (tmin+tmax)*0.5 + (tmax-tmin)*0.5*sin(time*0.01);
        double tmod = (tmin+tmax)*0.5;
        CJointedRigidBody& sgg = aSggJRB[isgg]; 
        const CDesModeBound& dmb = aDesModeBound[isgg];
        sgg = jrb;
        MoveInitialDesignAnchor(aDesModeBound[isgg].desMode,tmod,
                                sgg.aRI, sgg.aFix, sgg.aFP);
        JointConnectivityEnforcement_ChangeBoxLen(sgg);
        sgg.PlaceNails();        
        ContactEnforcement_ChangeBoxLen(sgg);        
        DrawModeDist(sgg,dmb,tmod,hvh);
      }            
      for(unsigned int ifix=0;ifix<aSggJRB[isgg].aJFixForce.size();ifix++){ aSggJRB[isgg].aJFixForce[ifix].Clear(); }      
      {
        CJointedRigidBody& sgg = aSggJRB[isgg]; 
        std::vector<unsigned int> aIndRBPicked;         
        if( isgg < aDesModeBound.size() ){
          const CDesModeBound& dmb = aDesModeBound[isgg];
          if( dmb.irb0 >=0 && dmb.irb0 < sgg.aRI.size() ){ 
            aIndRBPicked.push_back( dmb.irb0 );
            if( dmb.irb1 >=0 && dmb.irb1 < sgg.aRI.size() ){ 
              aIndRBPicked.push_back( dmb.irb1 ); 
              if( dmb.irb2 >=0 && dmb.irb2 < sgg.aRI.size() ){ 
                aIndRBPicked.push_back( dmb.irb2 ); 
              }
            }
          }
        }
        else{
          for(unsigned int irb=jrb.aRI.size();irb<sgg.aRI.size();irb++){
            aIndRBPicked.push_back(irb);
          }
        }
//        GLfloat color[4] = { 0.6f, 0.6f, 1.0f, 0.9f };        
        GLfloat color_blue[4] = { 0.6f, 0.6f, 1.0f, 0.9f };        
        aSggJRB[isgg].Draw(false, aIndRBPicked, color_blue, zscr);        
      }

      if( isgg_hover == isgg ){ 
        ::glDisable(GL_LIGHTING);
        ::glDisable(GL_BLEND);
        ::glDisable(GL_DEPTH_TEST);
        ::glMatrixMode(GL_PROJECTION);
        ::glLoadIdentity();
        ::glMatrixMode(GL_MODELVIEW);
        ::glLoadIdentity();
        ::glColor3d(1,0,0);
        ::glLineWidth(6);
        ::glBegin(GL_LINE_LOOP);
        ::glVertex3d(-1,-1,+0.8);
        ::glVertex3d(+1,-1,+0.8);
        ::glVertex3d(+1,+1,+0.8);
        ::glVertex3d(-1,+1,+0.8);
        ::glEnd();
        ::glEnable(GL_DEPTH_TEST);
        ::glEnable(GL_BLEND);        
        ::glEnable(GL_LIGHTING);
      }
    }
  }
  
  
/*  
  if( glutGetWindow() == iwin_des ){
//    if( is_sketch ){
      ::glDisable(GL_DEPTH_TEST);        
      ::glDisable(GL_LIGHTING);      
      ::glLineWidth(2);
      ::glEnable(GL_LINE_SMOOTH);
      ::glColor3d(0,0,0);
      for(unsigned int ist=0;ist<aStroke.size();ist++){
        ::glBegin(GL_LINE_STRIP);
        for(unsigned int ip=0;ip<aStroke[ist].size()-1;ip++){
          ::glVertex2d(aStroke[ist][ip+0].x, aStroke[ist][ip+0].y);
          ::glVertex2d(aStroke[ist][ip+1].x, aStroke[ist][ip+1].y);
        }
        ::glEnd();        
      }
      ::glDisable(GL_LINE_SMOOTH);
      ::glEnable(GL_LIGHTING);
      ::glEnable(GL_DEPTH_TEST);                                            
//    }    
  }
  if( glutGetWindow() == iwin_sim ){
    ::glDisable(GL_BLEND);
    ::glDisable(GL_LIGHTING);
    Fem::Field::View::CColorMap cm;    
    cm.SetMinMax(0,10);
    Fem::Field::View::DrawColorLegend2(cm);
    ::glEnable(GL_BLEND);    
    ::glEnable(GL_LIGHTING);    
    
    jrb.Draw(true);          
    ::glDisable(GL_DEPTH_TEST);
    for(unsigned int icst=0;icst<jrb.aFix.size();icst++){      
      const CJoint_Fix& cst   = jrb.aFix[icst];
      const unsigned int irb0 = cst.aIndRB[0]; 
      const CRigidBody3D& rb0 = jrb.aRB[irb0]; 
      Com::CVector3D vec_j = rb0.GetCurrentPositionFromInitial(cst.ini_pos_joint); // joint pos
      ::glPushMatrix();
      ::glTranslated( vec_j.x, vec_j.y, vec_j.z );  // joint position  
      
      Com::CVector3D v = Com::CVector3D(cst.lambda[3], cst.lambda[4], cst.lambda[5]);
      double e = Dot(v,v);
      GLfloat pink[4] = {0,0,0,1};
      cm.GetColor(pink, e);
      std::cout << icst << " " << e << std::endl;
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, pink);
      ::glutSolidSphere(0.1,10,5);
      ::glPopMatrix();
    }
    ::glEnable(GL_DEPTH_TEST);    
  }
  */
  
  
  /*
  {
    const bool is_light = glIsEnabled(GL_LIGHTING);
    ::glDisable(GL_LIGHTING);
    ::glLineWidth(1);
    ::glBegin(GL_LINES);
    ::glColor3d(1,0,0);	::glVertex3d(0,0,0);	::glVertex3d(1,0,0);
    ::glColor3d(0,1,0);	::glVertex3d(0,0,0);	::glVertex3d(0,1,0);
    ::glColor3d(0,0,1);	::glVertex3d(0,0,0);	::glVertex3d(0,0,1);
    ::glEnd();    
    if( !is_light ){ ::glDisable(GL_LIGHTING); }
    else{ ::glEnable(GL_LIGHTING); }
  }
   */
  
//  std::cout << xmin << " " << xmax << " " << ymin << " " << ymax << std::endl;  
  /*
  if( ind_picked_obj >= 0 && is_rigid_picked_obj ){
    if( xmin > -1 ){
      const double xdist = mov_begin_x - pic_scr_x;
      jrb.DrawPickedPlank(desSens_x,simSens_x,xmin-xdist, is_rigid_picked_obj,ind_picked_obj);
    }
    if( xmax < +1 ){
      const double xdist = mov_begin_x - pic_scr_x;      
      jrb.DrawPickedPlank(desSens_x,simSens_x,xmax-xdist, is_rigid_picked_obj,ind_picked_obj);
    }            
    if( ymin > -1 ){
      const double ydist = mov_begin_y - pic_scr_y;            
      jrb.DrawPickedPlank(desSens_y,simSens_y,ymin-ydist, is_rigid_picked_obj,ind_picked_obj);
    }    
    if( ymax < +1 ){
      const double ydist = mov_begin_y - pic_scr_y;                  
      jrb.DrawPickedPlank(desSens_y,simSens_y,ymax-ydist, is_rigid_picked_obj,ind_picked_obj);
    }        
  }
   */
    
//  if( jrb.ind_picked_obj != -1 ){
  /*
  {
    ::glPointSize(5);
    ::glColor3d(1,0,0);
    ::glBegin(GL_POINTS);
    ::glVertex3d(pic_pos_3d.x,pic_pos_3d.y,pic_pos_3d.z);
    ::glEnd();
  }
   */
  
  
//  ShowFPS();
    
	glutSwapBuffers();
}

int GetStatus(const CJointedRigidBody& jrb){
  for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){ // check joint-disconnect
    if( jrb.aFix[ifix].irb0 != ind_picked_obj && jrb.aFix[ifix].irb1 != ind_picked_obj ) continue;
    if( !CheckJointInside(ifix,jrb.aRI,jrb.aFix,jrb.aFixDir) ){
      return 1;
    }
  }    
  {  // check toppling
    for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
      const CRigid3D_Ini& ri = jrb.aRI[irb];        
      const CRigid3D_Def& rd = jrb.aRD[irb];        
      const CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
      for(unsigned int i=0;i<aCP.Size();i++){
        if( !aCP.aFP[i].is_force_cont ) continue;
        Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);  
        Com::CVector3D v1 = GetCurrentPosition(v0,ri,rd);
        const double depth1 = Com::Dot(jrb.contProp.cont_norm,jrb.contProp.cont_base-v1);
        Com::CVector3D cg = jrb.aRD[irb].GetDispCG() + jrb.aRI[irb].GetIniPosCG();
        const double depth2 = Com::Dot(jrb.contProp.cont_norm,cg-jrb.contProp.cont_base);
        if( depth1 < 0 ){ return 2; }
        if( depth2 < 0 ){ return 2; }
      }
    }
  }
  {
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      double shear, pull;
      DisplayJointCapacity(ifix, shear, pull,
                           jrb.aRI, jrb.aRD, 
                           jrb.aFix, 
                           jrb.aJFixForce, 
                           jrb.aFixDir, 
                           jrb.aNailJoint);
      if( shear > 1 ){ return 3; }
      if( pull  > 1 ){ return 3; }
      //      std::cout << ifix << "   shear : " << shear*100 << "    pull : " << pull*100 << std::endl;               
    }    
  }
  return 0;
}

void myGlutIdle(){
  ::glutSetWindow(iwin_des);
	::glutPostRedisplay();
  ::glutSetWindow(iwin_sim);  
	::glutPostRedisplay();  
  ::glutSetWindow(iwin_sgg);  
	::glutPostRedisplay();    
  
  if( imode_system == 1 ){  // optimization    
    EnforceContact_ChangeBoxLen(jrb.aRI,jrb.aFP,jrb.contProp.cont_norm,jrb.contProp.cont_base);    
    EnforceJointConnectivity_ChangeBoxLen(jrb.aRI,jrb.aFix,jrb.aFixDir);
    for(unsigned int itr=0;itr<20;itr++){
      Optimize_GradModes
      (1.0e-5,
       jrb.aRI,  jrb.aRD,
       jrb.aFix, jrb.aJFixForce, jrb.aFixDir, 
       jrb.aExForce,
       ////
       jrb.gravity, jrb.contProp, jrb.aFP);            
    }
    jrb.PlaceNails();    
    bool is_stable = true;
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      double shear, pull;
      DisplayJointCapacity(ifix, shear, pull,
                           jrb.aRI, jrb.aRD, 
                           jrb.aFix, 
                           jrb.aJFixForce, 
                           jrb.aFixDir, 
                           jrb.aNailJoint);
      if( shear > 1 || pull > 1 ){
        is_stable = false;
        break;
      }
    }  
    if( is_stable ){
      imode_system = 0;
      rigid_edit_mode = -1;
    }
  }  
  
  istat_struc = GetStatus(jrb);

//  std::cout << is_animation << std::endl;  
  if( is_animation ){

    //    StepTime_NewmarkBetaAPrime(aRB,apFix,dt,newmark_gamma,newmark_beta,gravity, cont_base,cont_norm,cont_stiff);	// solve rigid motion
    /*
    if( !is_converged ){
      for(;;){
        bool res = jrb.StepTime_BackwardEular(dt);	// solve rigid motion    
        if( res ){
          is_converged = true;
          break;
        }
      }
    }*/
//  if( is_cont_update ){  
    if( imode_userstudy != 0 && imode_userstudy != 5 ){
      SolveStaticEquilibrium(jrb.aRI,jrb.aRD,jrb.aFix,jrb.aJFixForce,jrb.aExForce,
                             jrb.gravity,jrb.contProp,jrb.aFP);
    }
    else if( imode_userstudy == 5 ){
      double resn, updn;
      StepTime_BackwardEular(jrb,dt,resn,updn);	// solve rigid motion
    }
    
//      if( is_optimization_mode ){
//        StepTime_BackwardEular_UntactAnchor(jrb, dt, resn, updn);
//      }
//      else{//      }
//    }
    
//    }
//    else{
//      jrb.StepTime_BackwardEular_UntactAnchor(dt);
//    }
//    cur_time += dt;
    /*
     */
    //    std::cout << "cur time " << cur_time << " " << eng << std::endl;
  }
}

bool GetPos2AddPlank(Com::CVector3D& pos2, double mov_end_x, double mov_end_y){
  Com::CVector3D src, dir;
  camera_des.GetRayVerticalScreen(mov_end_x, mov_end_y, src, dir);        
  Com::CVector3D pic_pos_3d;
  unsigned int iface_picked_obj;
  ind_picked_obj = PickBox_Ini(src,-dir,
                               pic_pos_3d,iface_picked_obj,
                               jrb.aRI);         
  Com::CVector3D t0;
  if( iface0_addplank == 4 || iface0_addplank == 5 || irb0_addplank < 0 ){
    t0 = n0_addplank;    
  }
  else {  
    t0 = x0_addplank;
  }
  Com::CVector3D t0_snap;
  double lx = fabs(t0.x);
  double ly = fabs(t0.y);
  double lz = fabs(t0.z);    
  if( lx > ly && lx > lz ){ t0_snap = Com::CVector3D(1,0,0); }
  if( ly > lz && ly > lx ){ t0_snap = Com::CVector3D(0,1,0); }
  if( lz > lx && lz > ly ){ t0_snap = Com::CVector3D(0,0,1); }  

  const Com::CVector3D& d1 = pos1_addplank-pos0_addplank;        
  if( Com::Length(d1) < 1.0e-10 ){
    return false;
  }
  double t = Dot(pos1_addplank-src,d1)/Dot(d1,dir);  
  Com::CVector3D cand = src+t*dir;        
  if( ind_picked_obj == -1 || ind_picked_obj == irb0_addplank ){
    Com::CVector3D c0 = Dot(cand-pos1_addplank,t0)*t0 + pos1_addplank;
    Com::CVector3D c1 = Dot(cand-pos1_addplank,t0_snap)*t0_snap + pos1_addplank;
    if( Com::Length(cand-c0) > Com::Length(cand-c1) ){
      pos2 = c1; return true;
    }
    else {
      pos2 = c0; return true;
    }          
  }
  else{
    const CRigid3D_Ini& ri0 = jrb.aRI[ind_picked_obj];
    const Com::CVector3D& p0 = ri0.GetIniPosCG();
    const Com::CVector3D& n0 = ri0.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
    double t0 = Dot(p0-pos1_addplank,n0)/Dot(n0_addplank,n0);          
    Com::CVector3D c0 = pos1_addplank + t0*n0_addplank;
    double t1 = Dot(p0-pos1_addplank,n0)/Dot(t0_snap,n0);                    
    Com::CVector3D c1 = pos1_addplank + t1*t0_snap;
    double t2 = Dot(p0-src,n0)/Dot(dir,n0);
    const Com::CVector3D& p2 = src + t2*dir;
    Com::CVector3D c2 = Com::GetMinDist_LinePoint(pos1_addplank,p2,d1);
    double l0 = Com::Length(cand-c0);
    double l1 = Com::Length(cand-c1);          
    double l2 = Com::Length(cand-c2)*3;             
    if(      l0 < l1 && l0 < l2 ){ 
      pos2 = c0; return true;
    }
    else if( l1 < l2 && l1 < l0 ){
      pos2 = c1; return true;
    }                    
    else if( l2 < l0 && l2 < l1 ){
      pos2 = c2; return true;
    }                   
  }
}

void myGlutPassiveMotion( int x, int y ){
  GLint viewport[4];
	::glGetIntegerv(GL_VIEWPORT,viewport);
  const int win_w = viewport[2];
	const int win_h = viewport[3];
	const double mov_end_x = (2.0*x-win_w)/win_w;
	const double mov_end_y = (win_h-2.0*y)/win_h;  
  if( glutGetWindow() == iwin_sgg ){    
    double aspf = camera_des.GetWindowAspect();
    int win_w = glutGet(GLUT_WINDOW_WIDTH);
    int win_h = glutGet(GLUT_WINDOW_HEIGHT);    
    double aspw = (double)win_w/win_h;
    unsigned int nsgg = aSggJRB.size();
    //    std::cout << aspf << " " << aspw << " " << nsgg << std::endl;
    unsigned int nclm;
    for(nclm=1;nclm<nsgg;nclm++){
      unsigned int nrow = nsgg/nclm;
      if( nsgg%nclm != 0 ) nrow++; 
      if( aspw*nrow <= nclm*aspf ) break;
    }
    unsigned int nrow;
    for(nrow=1;nrow<nsgg;nrow++){
      unsigned int nclm = nsgg/nrow;
      if( nsgg%nrow != 0 ) nclm++; 
      if( aspf*nclm <= nrow*aspw ) break;
    }          
    int swin_w, swin_h;
    if( (double)win_w/nclm > (double)win_h/nrow*aspf ){
      swin_w = win_w/nclm;
      swin_h = swin_w/aspf;
    }
    else{
      swin_w = win_h/nrow*aspf;
      swin_h = win_h/nrow;
      nclm = nsgg/nrow;
      if( nsgg%nrow != 0 ) nclm++;
    }    
    isgg_hover = -1;    
    for(unsigned int isgg=0;isgg<nsgg;isgg++){
      unsigned int irw = isgg/nclm;
      unsigned int icl = isgg-nclm*irw; 
      if( x > icl*swin_w && x < (icl+1)*swin_w && y > irw*swin_h && y < (irw+1)*swin_h ){
        isgg_hover = isgg;
        break;
      }
    }
  }
  if( glutGetWindow() == iwin_des ){
    if( imode_system == 2 ){      
      if( nPosAddPlank == 2 ){
        double rat = 0.1;
        if( mov_end_x < -1-rat || mov_end_x > 1+rat || mov_end_y < -1-rat || mov_end_y > 1+rat ){
          double max_ratio = 1;
          max_ratio = ( (-mov_end_x+1)*0.5 > max_ratio  ) ? (-mov_end_x+1)*0.5 : max_ratio;
          max_ratio = ( (-mov_end_y+1)*0.5 > max_ratio  ) ? (-mov_end_y+1)*0.5 : max_ratio;
          max_ratio = ( (+mov_end_x+1)*0.5 > max_ratio  ) ? (+mov_end_x+1)*0.5 : max_ratio;
          max_ratio = ( (+mov_end_y+1)*0.5 > max_ratio  ) ? (+mov_end_y+1)*0.5 : max_ratio; 
          max_ratio = (max_ratio-1.0)*0.1+1;
          camera_des.SetScale(camera_des.GetScale()*(1.0/max_ratio));
          ::glMatrixMode(GL_PROJECTION);
          glLoadIdentity();
          Com::View::SetProjectionTransform(camera_des);     
          mov_begin_x = mov_end_x;
          mov_begin_y = mov_end_y;
          ::glutPostRedisplay();    
          return;
        }        
        Com::CVector3D pos2;
        bool res = GetPos2AddPlank(pos2,mov_end_x,mov_end_y);
        if( res ){
          pos2_addplank = pos2;
        }
        else{
          nPosAddPlank = 0;
        }
      }
    }
    if( imode_system == 3 ){ // add/del mode
      Com::CVector3D src, dir;
      camera_des.GetRayVerticalScreen(mov_end_x, mov_end_y, src, dir);
      Com::CVector3D pic_pos_3d;            
      rigid_edit_mode = -1;
      unsigned int iface_picked_obj;      
      ind_picked_obj = PickBox_Ini(src,-dir,
                                   pic_pos_3d,iface_picked_obj,
                                   jrb.aRI);
    }    
  }
}

bool CanConnectPlank(const CRigid3D_Ini& ri0, const CRigid3D_Ini& ri1,
                     unsigned int& idir0, unsigned int& idir1,
                     Com::CVector3D& jpos)
{  
  Com::CVector3D n0 = ri0.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
  Com::CVector3D p0 = ri0.GetIniPosCG();
  
  Com::CVector3D n1 = ri1.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );          
  Com::CVector3D p1 = ri1.GetIniPosCG();          
  Com::CVector3D b1[4];
  b1[0] = p1 + ri1.xlen*ri1.GetRotMatrix_Ini().MatVec( Com::CVector3D(+1, 0,0)*0.5 ); 
  b1[1] = p1 + ri1.xlen*ri1.GetRotMatrix_Ini().MatVec( Com::CVector3D(-1, 0,0)*0.5 ); 
  b1[2] = p1 + ri1.ylen*ri1.GetRotMatrix_Ini().MatVec( Com::CVector3D( 0,+1,0)*0.5 ); 
  b1[3] = p1 + ri1.ylen*ri1.GetRotMatrix_Ini().MatVec( Com::CVector3D( 0,-1,0)*0.5 ); 
  double d[4] = {
    fabs( Com::Dot(b1[0]-p0,n0) ),
    fabs( Com::Dot(b1[1]-p0,n0) ),
    fabs( Com::Dot(b1[2]-p0,n0) ),
    fabs( Com::Dot(b1[3]-p0,n0) ) };
  idir0 = ( Com::Dot(p1-p0,n0) > 0 ) ? 4 : 5;
  idir1 = 0;
  {
    double dmin = d[0];
    for(unsigned int i=1;i<4;i++){
      if( d[i] < dmin ){ dmin = d[i]; idir1=i; }
    }
  }          
//  std::cout << idir1 << " " << d[idir1] << " " << ri0.zlen << std::endl;
  if( d[idir1] > ri0.zlen ) return false;
  Com::CVector3D a,b;
  bool res = GetIntersectionOfTwoPlanks(a, b,
                                        ri0, ri1,
                                        idir0, idir1);  
  jpos = (a+b)*0.5;
  return res;
}

void myGlutMotion( int x, int y ){
	GLint viewport[4];
	::glGetIntegerv(GL_VIEWPORT,viewport);
	const int win_w = viewport[2];
	const int win_h = viewport[3];
	const double mov_end_x = (2.0*x-win_w)/win_w;
	const double mov_end_y = (win_h-2.0*y)/win_h;
  if( glutGetWindow() == iwin_des ){  // widen the view
    double rat = 0.1;
    if( mov_end_x < -1-rat || mov_end_x > 1+rat || mov_end_y < -1-rat || mov_end_y > 1+rat ){
      double max_ratio = 1;
      max_ratio = ( (-mov_end_x+1)*0.5 > max_ratio  ) ? (-mov_end_x+1)*0.5 : max_ratio;
      max_ratio = ( (-mov_end_y+1)*0.5 > max_ratio  ) ? (-mov_end_y+1)*0.5 : max_ratio;
      max_ratio = ( (+mov_end_x+1)*0.5 > max_ratio  ) ? (+mov_end_x+1)*0.5 : max_ratio;
      max_ratio = ( (+mov_end_y+1)*0.5 > max_ratio  ) ? (+mov_end_y+1)*0.5 : max_ratio; 
      max_ratio = (max_ratio-1.0)*0.1+1;
      camera_des.SetScale(camera_des.GetScale()*(1.0/max_ratio));
      ::glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      Com::View::SetProjectionTransform(camera_des);     
      mov_begin_x = mov_end_x;
      mov_begin_y = mov_end_y;
      ::glutPostRedisplay();    
      return;
    }
  }
  if( glutGetWindow() == iwin_des ){  
    if( imodifier == GLUT_ACTIVE_CTRL ){
      camera_des.MouseRotation(mov_begin_x,mov_begin_y,mov_end_x,mov_end_y); 
    }
    else if( imodifier == GLUT_ACTIVE_SHIFT ){
      camera_des.MousePan(mov_begin_x,mov_begin_y,mov_end_x,mov_end_y); 
    }    
    else if( imode_system == 0 ){
      if( desModeBound.irb0 >= 0 && desModeBound.irb0 < jrb.aRI.size() && ipicked_rb >=0 && ipicked_rb < 3 ){
        aSggJRB.clear();
        aDesModeBound.clear();
        const Com::CMatrix3& cr = camera_des.GetRotMatrix3();
        const double asp = camera_des.GetWindowAspect();
        const double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
        int irb=-1, imo=-1;
        double rm;
        std::cout << "ipickd rb " << ipicked_rb << std::endl;
        if( ipicked_rb == 0 ){
          irb = desModeBound.irb0;
          imo = desModeBound.imode0;
          rm = desModeBound.r0;
        }
        else if( ipicked_rb == 1 ){
          irb = desModeBound.irb1;
          imo = desModeBound.imode1;          
          rm = desModeBound.r1;          
        }
        else if( ipicked_rb == 2 ){
          irb = desModeBound.irb2;
          imo = desModeBound.imode2;          
          rm = desModeBound.r2;          
        }        
        std::cout << "mode drag" << irb << " " << imo << " " << rm << std::endl;        
        double del_mode = DragAPlank(irb,
                                     imo, 
                                     jrb.aRI,jrb.aRD,jrb.aFix,jrb.aFixDir,jrb.aJFixForce,jrb.aFP, 
                                     mov_begin_x*hvh*asp, mov_begin_y*hvh, 
                                     mov_end_x*hvh*asp,   mov_end_y*hvh, 
                                     cr,
                                     camera_des.GetCenterPosition(),
                                     camera_des.GetObjectCenter());
        if( imo >= 0 ){
          del_mode /= rm;
          assert( simSens.aPlankPR.size() == jrb.aRI.size() );
          assert( simSens.aJointLM.size() == jrb.aFix.size() );
          MoveInitialDesignAnchor(desModeBound.desMode,del_mode, jrb.aRI,jrb.aFix,jrb.aFP);    // hoge
//          MoveInitialDesign(desModeBound.desMode,del_mode, jrb.aRI,jrb.aFix);     //hoge         
          if( imode_userstudy >= 2 ){
            MoveCurrentDeform(simSens,del_mode, jrb.aRD,jrb.aJFixForce);    // hoge
          }
          EnforceJointConnectivity_ChangeBoxLen(jrb.aRI,jrb.aFix,jrb.aFixDir,false);          
          EnforceContact_ChangeBoxLen(jrb.aRI,jrb.aFP,jrb.contProp.cont_norm,jrb.contProp.cont_base);
          jrb.PlaceNails();
          tmode += del_mode;
        }
      }
      aSggJRB.clear();              
      {
        unsigned int nflip = 0;
        std::vector<unsigned int> aIndFix_Flip;        
        for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
          if( jrb.aFix[ifix].irb0 != ind_picked_obj && jrb.aFix[ifix].irb1 != ind_picked_obj ) continue;
          if( !CheckJointInside(ifix,jrb.aRI,jrb.aFix,jrb.aFixDir) ){
            nflip++;
            aIndFix_Flip.push_back(ifix);
          }
        }
        assert( nflip < 4 );
        unsigned int nsgg = 1;        
        for(unsigned int iflip=0;iflip<nflip;iflip++){ nsgg *= 2; }
        if( nsgg != 1 ){
          aSggJRB.resize(nsgg,jrb);
          for(unsigned int isgg=0;isgg<nsgg;isgg++){
            CJointedRigidBody& jrb1 = aSggJRB[isgg];
            if( (isgg/1)%2==1 ){ FlipJoint(aIndFix_Flip[0],jrb1.aRI,jrb1.aFix,jrb1.aFixDir); }            
            if( (isgg/2)%2==1 ){ FlipJoint(aIndFix_Flip[1],jrb1.aRI,jrb1.aFix,jrb1.aFixDir); }
            if( (isgg/4)%2==1 ){ FlipJoint(aIndFix_Flip[2],jrb1.aRI,jrb1.aFix,jrb1.aFixDir); }
            if( (isgg/8)%2==1 ){ FlipJoint(aIndFix_Flip[3],jrb1.aRI,jrb1.aFix,jrb1.aFixDir); } 
            JointConnectivityEnforcement_ChangeBoxLen(aSggJRB[isgg]);
            ContactEnforcement_ChangeBoxLen(aSggJRB[isgg]);
            jrb1.PlaceNails();
            SolveStaticEquilibrium(jrb1.aRI,jrb1.aRD,jrb1.aFix,jrb1.aJFixForce,jrb1.aExForce,
                                   jrb1.gravity,jrb1.contProp,jrb1.aFP); 
          }
        }        
      }
      if( ind_picked_obj >= 0 && ind_picked_obj < jrb.aRI.size() ){        
        unsigned int irb0 = ind_picked_obj;
        for(unsigned int irb1=0;irb1<jrb.aRI.size();irb1++){
          if( irb0 == irb1 ) continue;
          bool is_joint = false;
          for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
            if( jrb.aFix[ifix].irb0 == irb0 && jrb.aFix[ifix].irb1 == irb1 ){ is_joint = true; break; }
            if( jrb.aFix[ifix].irb0 == irb1 && jrb.aFix[ifix].irb1 == irb0 ){ is_joint = true; break; }
          }
          if( is_joint ) continue; // there is already a joint connecting irb0 and irb1
          const CRigid3D_Ini& ri0 = jrb.aRI[irb0];
          const CRigid3D_Ini& ri1 = jrb.aRI[irb1];
          unsigned int idir0, idir1;
          Com::CVector3D jpos;          
          if( CanConnectPlank(ri0, ri1, idir0, idir1, jpos) ){
            CJointedRigidBody jrb0 = jrb;
            jrb0.AddFixJoint(irb0,irb1,
                             idir0, idir1, 
                             jpos,
                             Com::CVector3D(1,0,0),
                             Com::CVector3D(0,1,0),
                             Com::CVector3D(0,0,1),
                             jrb.invstiff_pos, jrb.invstiff_rot);
            JointConnectivityEnforcement_ChangeBoxLen(jrb0);
            ContactEnforcement_ChangeBoxLen(jrb0);            
            jrb0.PlaceNails();
            jrb0.ClearValue();
            aSggJRB.push_back(jrb0);            
          }          
          if( CanConnectPlank(ri1, ri0, idir1, idir0, jpos) ){
            CJointedRigidBody jrb0 = jrb;
            jrb0.AddFixJoint(irb1,irb0,
                             idir1, idir0, 
                             jpos,
                             Com::CVector3D(1,0,0),
                             Com::CVector3D(0,1,0),
                             Com::CVector3D(0,0,1),
                             jrb.invstiff_pos, jrb.invstiff_rot);
            JointConnectivityEnforcement_ChangeBoxLen(jrb0);
            ContactEnforcement_ChangeBoxLen(jrb0);            
            jrb0.PlaceNails();
            jrb0.ClearValue();
            aSggJRB.push_back(jrb0);            
          }          
        }
      }
    }
    else if( imode_system == 2 ){ // add/del mode
      Com::CVector3D src, dir;
      camera_des.GetRayVerticalScreen(mov_end_x, mov_end_y, src, dir);
      if( nPosAddPlank == 1 ){
        double t = Dot(pos0_addplank-src,n0_addplank)/Dot(dir,n0_addplank);        
        Com::CVector3D cand = src+dir*t;
        Com::CVector3D c0 = Dot(cand-pos0_addplank,x0_addplank)*x0_addplank+pos0_addplank;
        Com::CVector3D y0_addplank = Cross(x0_addplank,n0_addplank);
        Com::CVector3D c1 = Dot(cand-pos0_addplank,y0_addplank)*y0_addplank+pos0_addplank;
        if( Distance(c0,cand) < Distance(c1,cand) ){ pos1_addplank = c0; }
        else{ pos1_addplank = c1; }
      }
    }            
    else if( imode_system == 3 ){
    }
    else if( imode_system == 4 ){
      Com::CVector3D src0, dir0;
      camera_des.GetRayVerticalScreen(mov_end_x, mov_end_y, src0, dir0);
      for(unsigned int ief=0;ief<jrb.aExForce.size();ief++){
        CExternalForceOnRigidBody& ef = jrb.aExForce[ief];
        unsigned int iri = ef.irb;          
        const CRigid3D_Ini& ri = jrb.aRI[iri];
        Com::CVector3D p = ri.GetInitialPosition(ef.pos);
        Com::CVector3D ez = ri.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
        const double r = Com::Length(ef.force*0.001);        
        Com::CVector3D q = Com::GetMinDist_LinePoint(p,src0,dir0);
        if( Distance(p,q) > 0.03 ){
          Com::CVector3D ez = ri.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
          double t0 = Com::Dot(p-src0,ez)/Com::Dot(dir0,ez);
          Com::CVector3D s0 = src0+t0*dir0;
          double dist0 = Distance(s0,p);   
          if( dist0 < r*1.5 ){
            Com::CVector3D src1, dir1;
            camera_des.GetRayVerticalScreen(mov_begin_x, mov_begin_y, src1, dir1);            
            double t1 = Com::Dot(p-src1,ez)/Com::Dot(dir1,ez);
            Com::CVector3D s1 = src1+t1*dir1;            
            double dist1 = Distance(s1,p);   
            ef.force *= dist0/dist1;
//            std::cout << ef.force  << std::endl;
          }
        }
      }
    }
  }
  else if( glutGetWindow() == iwin_sim ){
    if( imodifier == GLUT_ACTIVE_CTRL ){
      camera_sim.MouseRotation(mov_begin_x,mov_begin_y,mov_end_x,mov_end_y); 
    }
    else if( imodifier == GLUT_ACTIVE_SHIFT ){
      camera_sim.MousePan(mov_begin_x,mov_begin_y,mov_end_x,mov_end_y); 
    }
    else{
      /*
      if( !jrb.is_rigid_picked_obj && jrb.ind_picked_obj >= 0 && jrb.ind_picked_obj < jrb.aFix.size() ){
        Rigid::CJoint_Fix& cjs = jrb.aFix[jrb.ind_picked_obj];
        const Com::CVector3D& v = camera_sim.ProjectionOnPlane(mov_end_x,mov_end_y, 0,0,0, 0,0,1);
        unsigned int irb0 = cjs.aIndRB[0];
        const Rigid::CRigidBody3D& rb0 = jrb.aRB[irb0];
        Com::CVector3D u = rb0.GetRotMatrix_Inc().MatVecTrans(v-rb0.GetIniPosCG()-rb0.GetDispCG())+rb0.GetIniPosCG();
        cjs.ini_pos_joint = u;         
      }            
       */
    }    
  }
	mov_begin_x = mov_end_x;
	mov_begin_y = mov_end_y;
	::glutPostRedisplay();
}


void myGlutMouse(int button, int state, int x, int y){
  if( imode_system == 0 ){
    is_show_feedback = false;
    if( imode_userstudy == 0 ){
      for(unsigned int ifix=0;ifix<jrb.aJFixForce.size();ifix++){            
        for(unsigned int i=0;i<6;i++){
          jrb.aJFixForce[ifix].lambda[i] = 0;
        }
      }
    }            
  }
  if( state == GLUT_DOWN ){ is_button_pressed = true; }
  else{ is_button_pressed = false; }
	GLint viewport[4];
	::glGetIntegerv(GL_VIEWPORT,viewport);
	const int win_w = viewport[2];
	const int win_h = viewport[3];
	mov_begin_x = (2.0*x-win_w)/win_w;
	mov_begin_y = (win_h-2.0*y)/win_h;
  imodifier = glutGetModifiers();    
//  std::cout << mov_begin_x << " " << mov_begin_y << std::endl;
  if( glutGetWindow() == iwin_sim ){
  }
  else if( glutGetWindow() == iwin_sgg ){
    if( state == GLUT_DOWN ){
      double aspf = camera_des.GetWindowAspect();
      int win_w = glutGet(GLUT_WINDOW_WIDTH);
      int win_h = glutGet(GLUT_WINDOW_HEIGHT);    
      unsigned int nsgg = aSggJRB.size();      
      int swin_w, swin_h;
      unsigned int nclm;
      PackedSugImages(nsgg, aspf, win_w, win_h, swin_w, swin_h, nclm);      
      double aspw = (double)win_w/win_h;
      //    std::cout << aspf << " " << aspw << " " << nsgg << std::endl;
      bool is_suggested = false;
      for(unsigned int isgg=0;isgg<nsgg;isgg++){
        unsigned int irw = isgg/nclm;
        unsigned int icl = isgg-nclm*irw; 
        if( x > icl*swin_w && x < (icl+1)*swin_w && y > irw*swin_h && y < (irw+1)*swin_h ){
          if( isgg < aDesModeBound.size() ){
            jrb = aSggJRB[isgg];            
            desModeBound = aDesModeBound[isgg];
            tmode = (desModeBound.tmin+desModeBound.tmax)*0.5;
          }
          else if( jrb.aRI.size()+1 == aSggJRB[isgg].aRI.size() ){
            ind_picked_obj = -1;
            unsigned int irb_add = aSggJRB[isgg].aRI.size()-1;
            jrb = aSggJRB[isgg];            
            CDesModeBound& dmb = desModeBound;
            dmb.irb0 = irb_add;
            dmb.imode0 = 2;
            dmb.irb1 = -1;
            GetDesignSensitivity(desModeBound.desMode, jrb.aRI,jrb.aFix,jrb.aFixDir,irb_add, 2, 0,jrb.contProp);
            jrb.GetSensitivityMove(simSens, desModeBound.desMode);
            tmode = 0;
            double tmode_min = -1;
            double tmode_max = +1;
            FindRangeSoundStructure_Bisec
            (tmode_min, tmode_max,
             desModeBound.desMode,
             jrb.aRI, jrb.aFix,jrb.aFixDir,
             jrb.gravity,jrb.contProp,
             ////
             jrb.aFP,jrb.aExForce,
             jrb.aNailJoint);
            ipicked_rb = 0;
            desModeBound.tmin = tmode_min;
            desModeBound.tmax = tmode_max;
//            desModeBound.irb0 = irb_add;
//            desModeBound.imode0 = 2;
            desModeBound.r0 = 1;
            desModeBound.irb1 = -1;            
          }
          else{
            jrb = aSggJRB[isgg];            
            desModeBound.irb0 = -1;
          }
          ind_picked_obj = -1;
          rigid_edit_mode = -1;
          aSggJRB.clear();
          is_suggested = true;
          break;
        }
      }
      /*
      if( is_suggested ){
        SolveStaticEquilibrium(jrb.aRI,jrb.aRD,jrb.aFix,jrb.aJFixForce,jrb.aExForce,
                               jrb.gravity,jrb.contProp,jrb.aFP); 
        istat_struc = GetStatus(jrb);
        std::cout << "suggested staus" << istat_struc << std::endl;
        if( istat_struc == 3 ){
          GetSuggestionModes_JointDurable
          (aDesModeBound,
           jrb.aRI, jrb.aRD, 
           jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
           ////
           jrb.gravity, jrb.contProp, jrb.aFP);         
          aSggJRB.resize(aDesModeBound.size(),jrb);         
          std::cout << "suggested shapes" << aDesModeBound.size() << std::endl;
          return;
        }
      } 
       */
    }
  }
  else if( glutGetWindow() == iwin_des ){    
    if( imodifier != 0 ) return;
    {
      bool res = PickMenu(mov_begin_x,mov_begin_y,state);
      if( res ){       
        return; 
      }
    }
    {
      bool res = PickFileMenu(mov_begin_x,mov_begin_y,state);
      if( res ){       
        return; 
      }    
    }
    if( imode_system == 0 ){
      if( state == GLUT_DOWN ){      
        Com::CVector3D src, dir;
        camera_des.GetRayVerticalScreen(mov_begin_x, mov_begin_y, src, dir);
        Com::CVector3D pic_pos_3d;        
        unsigned int iface_picked_obj;
        double hvh = camera_des.GetHalfViewHeight()/camera_des.GetScale();
        if( rigid_edit_mode == -1 && ind_picked_obj == -1 && desModeBound.irb0 >= 0 ){
          std::cout << "check des bound picked" << std::endl;
          const CDesModeBound& dmb = desModeBound;
          CDesignSensitivity desSens;          
          {
            int imo0 = dmb.imode0;
            int irb0 = dmb.irb0;
            PickAPlank_Ini(imo0,
                           irb0, 
                           iface_picked_obj,
                           pic_pos_3d,
                           desSens,
                           src,dir,
                           jrb.aRI, jrb.aFix, jrb.aFixDir, jrb.aFP,
                           hvh,
                           jrb.contProp);           
            if( imo0 == dmb.imode0 && irb0 == dmb.irb0 ){
              jrb.GetSensitivityMove(simSens, desModeBound.desMode);
              ipicked_rb = 0;              
              return;
            }
          }
          if( dmb.irb1 != -1 ){
            int imo1 = dmb.imode1;
            int irb1 = dmb.irb1;
            PickAPlank_Ini(imo1,
                           irb1, 
                           iface_picked_obj,
                           pic_pos_3d,
                           desSens,
                           src,dir,
                           jrb.aRI, jrb.aFix, jrb.aFixDir, jrb.aFP,
                           hvh,
                           jrb.contProp);         
            if( imo1 == dmb.imode1 && irb1 == dmb.irb1 ){
              jrb.GetSensitivityMove(simSens, desModeBound.desMode);              
              ipicked_rb = 1;              
              return;
            }       
          }
          if( dmb.irb2 != -1 ){
            int imo2 = dmb.imode2;
            int irb2 = dmb.irb2;
            PickAPlank_Ini(imo2,
                           irb2, 
                           iface_picked_obj,
                           pic_pos_3d,
                           desSens,
                           src,dir,
                           jrb.aRI, jrb.aFix, jrb.aFixDir, jrb.aFP,
                           hvh,
                           jrb.contProp);         
            std::cout << " pick mode2 " << imo2 << " " << dmb.imode2 << "   " << irb2 << " " << dmb.irb2 << std::endl;
            if( imo2 == dmb.imode2 && irb2 == dmb.irb2 ){
              jrb.GetSensitivityMove(simSens, desModeBound.desMode);              
              ipicked_rb = 2;              
              return;
            }       
          }          
          ind_picked_obj = -1;
          desModeBound.irb0 = -1;
          desModeBound.irb1 = -1;
          desModeBound.irb2 = -1;          
          ipicked_rb = -1;          
          return;
        }
        else{
          PickAPlank_Ini(rigid_edit_mode,
                         ind_picked_obj,                 
                         iface_picked_obj,
                         pic_pos_3d,
                         desModeBound.desMode,
                         src,dir,
                         jrb.aRI, jrb.aFix, jrb.aFixDir, jrb.aFP,
                         hvh,
                         jrb.contProp);          
          std::cout << "picked irb mode " << ind_picked_obj << " " << rigid_edit_mode << std::endl;
        }
        jrb_pre = jrb;
        desModeBound.irb0 = -1;
        if( rigid_edit_mode >= 0 ){
          jrb.GetSensitivityMove(simSens, desModeBound.desMode);
          tmode = 0;
          double tmode_min = -1;
          double tmode_max = +1;
          FindRangeSoundStructure_Bisec
          (tmode_min, tmode_max,
           desModeBound.desMode,
           jrb.aRI, jrb.aFix,jrb.aFixDir,
           jrb.gravity,jrb.contProp,
           ////
           jrb.aFP,jrb.aExForce,
           jrb.aNailJoint);
          ipicked_rb = 0;
          desModeBound.tmin = tmode_min;
          desModeBound.tmax = tmode_max;
          desModeBound.irb0 = ind_picked_obj;
          desModeBound.imode0 = rigid_edit_mode;
          desModeBound.r0 = 1;
          desModeBound.irb1 = -1;
//          aSggJRB.resize(1,jrb);
//          aDesModeBound.push_back(desModeBound);
        }
        return;
      }      
      if( imode_userstudy >= 2 ){
        if( state == GLUT_UP ){      
          if( istat_struc == 2 ){
            GetSuggestionModes_TopplingStable
            (aDesModeBound,
             jrb.aRI, jrb.aRD, 
             jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
             ////
             jrb.gravity, jrb.contProp, jrb.aFP);        
            aSggJRB.resize(aDesModeBound.size(),jrb);            
          }
          if( istat_struc == 3 ){
            clock_t start,middle,end;
            start = clock();
            std::cout << "start" << std::endl;  
            GetSuggestionModes_JointDurable
            (aDesModeBound,
             jrb.aRI, jrb.aRD, 
             jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
             ////
             jrb.gravity, jrb.contProp, jrb.aFP);        
            aSggJRB.resize(aDesModeBound.size());
            middle = clock();            
            std::cout << "continuous " << (double)(middle-start)/CLOCKS_PER_SEC << std::endl;
            MakeSuggestionSupportMaterial2(jrb,aSggJRB);                  
            end = clock();    
            std::cout << "discrete " << (double)(end-middle)/CLOCKS_PER_SEC << std::endl;            
            std::cout << "total: " << (double)(end-start)/CLOCKS_PER_SEC << std::endl;            
          }      
        }        
      }
    }
    if( imode_system == 2 ){  // add plank mode
      Com::CVector3D src, dir;
      camera_des.GetRayVerticalScreen(mov_begin_x, mov_begin_y, src, dir);
      Com::CVector3D pic_pos_3d;
      unsigned int iface_picked_obj;
      ind_picked_obj = PickBox_Ini(src,-dir,
                                   pic_pos_3d,iface_picked_obj,
                                   jrb.aRI);
      if( ind_picked_obj == -1 ){
        Com::CVector3D b = jrb.contProp.cont_base;
        Com::CVector3D n = jrb.contProp.cont_norm;
        double t = Dot(b-src,n)/Dot(n,dir);
        Com::CVector3D h = src+t*dir;
        if( t > -1 ){
          pic_pos_3d = h;
          ind_picked_obj = -2;
        }
      }
      if(      state == GLUT_DOWN ){ 
        if( nPosAddPlank == 0 && ind_picked_obj != -1 ){
          const Com::CVector3D aFaceNormal[6][3] = {
            { Com::CVector3D(+1, 0, 0), Com::CVector3D(0, 1, 0), Com::CVector3D(0, 0, 1) },
            { Com::CVector3D(-1, 0, 0), Com::CVector3D(0, 1, 0), Com::CVector3D(0, 0, 1) },
            { Com::CVector3D(+0,+1, 0), Com::CVector3D(1, 0, 0), Com::CVector3D(0, 0, 1) },
            { Com::CVector3D(-0,-1, 0), Com::CVector3D(1, 0, 0), Com::CVector3D(0, 0, 1) },
            { Com::CVector3D(+0, 0,+1), Com::CVector3D(1, 0, 0), Com::CVector3D(0, 1, 0) },
            { Com::CVector3D(-0, 0,-1), Com::CVector3D(1, 0, 0), Com::CVector3D(0, 1, 0) } };
          /////
          pos0_addplank = pic_pos_3d; 
          irb0_addplank = ind_picked_obj; 
          iface0_addplank = iface_picked_obj;
          pos1_addplank = pos0_addplank;
          nPosAddPlank = 1;
          if( ind_picked_obj >= 0 ){
            const CRigid3D_Ini& ri = jrb.aRI[ind_picked_obj];
            n0_addplank = ri.GetRotMatrix_Ini().MatVec( aFaceNormal[iface_picked_obj][0] );
            x0_addplank = ri.GetRotMatrix_Ini().MatVec( aFaceNormal[iface_picked_obj][2] );
          }
          else if( ind_picked_obj == -2 ){
            n0_addplank = jrb.contProp.cont_norm;
            x0_addplank = Com::CVector3D(1,0,0);
          }
        }
        else if( nPosAddPlank == 2 ){ // addplank
          Com::CVector3D c0;
          bool res = GetPos2AddPlank(c0,mov_begin_x,mov_begin_y);
          if( !res ){ nPosAddPlank = 0; return; }
          { // projection on floor
            Com::CVector3D b = jrb.contProp.cont_base;
            Com::CVector3D n = jrb.contProp.cont_norm;
            if( Dot(c0-b,n) < 0 ){            
              double t = Dot(b-c0,n)/Dot(n0_addplank,n);
              c0 += t*n0_addplank;
            }
          }
          pos2_addplank = c0;
          irb2_addplank = ind_picked_obj;
          iface2_addplank = iface_picked_obj;
          std::cout << "add plank "  << irb0_addplank << " " << iface0_addplank << "    " << irb2_addplank << " " << iface2_addplank << std::endl;
          {
            Com::CVector3D dx = pos2_addplank-pos1_addplank;
            Com::CVector3D dy = pos1_addplank-pos0_addplank;
            Com::CVector3D nx = dx; nx.SetNormalizedVector();
            Com::CVector3D ny = dy; ny.SetNormalizedVector();            
            Com::CVector3D nz = Cross(nx,ny);
            Com::CMatrix3 rot(nx,ny,nz);
            if( irb0_addplank == -2 ){
              jrb_pre = jrb;
              jrb.AddRigidBody_Box(dx.Length(),dy.Length(),jrb.lenz,jrb.rho,
                                   (pos0_addplank+pos2_addplank)*0.5,
                                   rot);            
              jrb.ClearValue();
              for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
                const CRigid3D_Ini& ri = jrb.aRI[irb]; 
                CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
                for(unsigned int i=0;i<aCP.Size();i++){
                  if( !aCP.aFP[i].is_force_cont ) continue;    
                  Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);            
                  Com::CVector3D v1 = ri.GetInitialPosition(v0);
                  aCP.aFP[i].aloc = v1;
                }
              }         
              desModeBound.irb0 = -1;
              desModeBound.irb1 = -1;              
            }
            else if( irb0_addplank >= 0 ){
              if( irb2_addplank < 0 || irb2_addplank == irb0_addplank ){
                jrb_pre = jrb;                
                jrb.AddRigidBody_BoxLeg(dx.Length(),dy.Length(),jrb.lenz,jrb.rho,
                                        (pos0_addplank+pos2_addplank)*0.5,
                                        rot,
                                        irb0_addplank, iface0_addplank);
                jrb.ClearValue();
              }
              else {
                jrb_pre = jrb;                
                jrb.AddRigidBody_BoxConnect(dx.Length(),dy.Length(),jrb.lenz,jrb.rho,
                                            (pos0_addplank+pos2_addplank)*0.5,
                                            rot,
                                            irb0_addplank, iface0_addplank,
                                            irb2_addplank, iface2_addplank);                                                                                     
              }
              jrb.ClearValue();              
              for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
                const CRigid3D_Ini& ri = jrb.aRI[irb]; 
                CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
                for(unsigned int i=0;i<aCP.Size();i++){
                  if( !aCP.aFP[i].is_force_cont ) continue;    
                  Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);            
                  Com::CVector3D v1 = ri.GetInitialPosition(v0);
                  aCP.aFP[i].aloc = v1;
                }
              }
              desModeBound.irb0 = -1;
              desModeBound.irb1 = -1;              
            }
          }
          nPosAddPlank = 0;
        }
      }
      if( state == GLUT_UP   ){ 
        /*
        pos1_addplank = pic_pos_3d; irb2_addplank = ind_picked_obj;
        if( irb0_addplank >= 0 && irb0_addplank < jrb.aRI.size() ){ // will be added
          if( irb2_addplank >= 0 && irb2_addplank < jrb.aRI.size() && irb0_addplank != irb2_addplank ){
            jrb.ConnectPlanks(irb0_addplank,irb2_addplank,pos0_addplank,pos1_addplank);
          }                 
          else{ // add leg
            double t = Com::Dot(pos0_addplank-src,dir)/Com::Dot(dir,dir);            
            Com::CVector3D pos1 = src + t*dir;
            jrb.AddLeg(irb0_addplank,pos0_addplank,pos1);
          }
        }
         */
        if( nPosAddPlank == 1 ){  // end second point
//          irb2_addplank = ind_picked_obj;
          double t = Dot(pos0_addplank-src,n0_addplank)/Dot(dir,n0_addplank);    
          Com::CVector3D cand = src+dir*t;
          Com::CVector3D c0 = Dot(cand-pos0_addplank,x0_addplank)*x0_addplank+pos0_addplank;
          Com::CVector3D y0_addplank = Cross(x0_addplank,n0_addplank);
          Com::CVector3D c1 = Dot(cand-pos0_addplank,y0_addplank)*y0_addplank+pos0_addplank;
          if( Distance(c0,cand) < Distance(c1,cand) ){ pos1_addplank = c0; }
          else{ pos1_addplank = c1; }          
          pos2_addplank = pos1_addplank;          
          nPosAddPlank = 2;
        }                
      }
    }
    if( imode_system == 3 ){  // delete plank
      if( state == GLUT_DOWN ){
        Com::CVector3D src, dir;
        camera_des.GetRayVerticalScreen(mov_begin_x, mov_begin_y, src, dir);
        Com::CVector3D pic_pos_3d;                
        unsigned int iface_picked_obj;
        ind_picked_obj = PickBox_Ini(src,-dir,
                                    pic_pos_3d,iface_picked_obj,
                                    jrb.aRI);
        if( ind_picked_obj >= 0 ){
          jrb_pre = jrb;          
          jrb.DeleteRigidBody(ind_picked_obj);
        }        
      }
    }
    if( imode_system == 4 ){ 
      if( state == GLUT_DOWN ){
        Com::CVector3D src, dir;
        camera_des.GetRayVerticalScreen(mov_begin_x, mov_begin_y, src, dir);
        Com::CVector3D pic_pos_3d;                
        unsigned int iface_picked_obj;
        const int ind_picked_obj0 = ind_picked_obj;
        ind_picked_obj = PickBox_Ini(src,-dir,
                                     pic_pos_3d,iface_picked_obj,
                                     jrb.aRI);   
        if(ind_picked_obj == -1 ){
          rigid_edit_mode = -1;
          return;
        }
        {
          bool is_force = false;
          for(unsigned int ief=0;ief<jrb.aExForce.size();ief++){
            const CExternalForceOnRigidBody& ef = jrb.aExForce[ief];
            unsigned int iri = ef.irb;          
            if( iri == ind_picked_obj ){             
              const CRigid3D_Ini& ri = jrb.aRI[iri];
              Com::CVector3D p = ri.GetInitialPosition(ef.pos);
              Com::CVector3D q = Com::GetMinDist_LinePoint(p,src,dir);
              if( Distance(p,q) < 0.05 ){
                if( rigid_edit_mode == -2 && ind_picked_obj0 == ind_picked_obj ){
                  jrb_pre = jrb;                
                  std::vector<CExternalForceOnRigidBody>::iterator itr = jrb.aExForce.begin()+ief;
                  jrb.aExForce.erase(itr);
                  return;
                }
                else{
                  rigid_edit_mode = -2;
                  return;
                }
              }
              else{
                Com::CVector3D ez = ri.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
                double t = Com::Dot(p-src,ez)/Com::Dot(dir,ez);
                Com::CVector3D s = src+t*dir;
                double dist = Distance(s,p);
                if( dist < Com::Length(ef.force)*0.001*1.2 ){
                  rigid_edit_mode = -3;
                  return;
                }
                else{
                  rigid_edit_mode = -1;
                  return;
                }
              }
              is_force = true;
            }
          }
          if( !is_force && ind_picked_obj0 == ind_picked_obj ){
            if( rigid_edit_mode == -1 ){
              rigid_edit_mode = -2;
            }
            if( rigid_edit_mode == -2 ){
              jrb_pre = jrb;            
              CExternalForceOnRigidBody ef(ind_picked_obj,
                                           Com::CVector3D(0,0,0),
                                           jrb.gravity*10.0);
              jrb.aExForce.push_back(ef);
            }
          }
        }        
      }
      if( state == GLUT_UP ){
        if( imode_userstudy >= 2 ){
          if( istat_struc == 3 ){
            GetSuggestionModes_JointDurable
            (aDesModeBound,
             jrb.aRI, jrb.aRD, 
             jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
             ////
             jrb.gravity, jrb.contProp, jrb.aFP);        
            aSggJRB.resize(aDesModeBound.size(),jrb);  
            MakeSuggestionSupportMaterial2(jrb,aSggJRB);                  
          }                    
        }
      }
    }
    /*
    std::cout << "src  : "<< src << std::endl;
    std::cout << "dir  : "<< dir << std::endl;
    std::cout << irb << std::endl;
     */
    /*
    Com::CVector3D p0 = camera_des.ProjectionOnPlane(mov_begin_x, mov_begin_y);
    std::cout << p0.x << " " << p0.y << std::endl;    
    unsigned int ist0 = aStroke.size();    
    if( state == GLUT_DOWN ){
      aStroke.resize( ist0+1 );
      aStroke[ist0].push_back( Com::CVector2D(p0.x,p0.y) );
    } 
     */
  }
}

void SetNewProblem()
{
  const unsigned int nprob = 5;
  static int iprob = 0;
  
  aDesModeBound.clear();
  desModeBound.irb0 = -1;
  aSggJRB.clear();
  jrb.Clear();
//  aOptDof.clear();
  // enviroment setting
  jrb.gravity = Com::CVector3D(0,-10,0);
  // contact setting
  jrb.contProp.cont_base = Com::CVector3D(0,0,0);
  const double tilt_angle = 0*3.1415/180.0;
  jrb.contProp.cont_norm = Com::CVector3D(sin(tilt_angle),cos(tilt_angle),0);
  jrb.contProp.stiff_n = 10000;
  jrb.contProp.stiff_f = 10000;
  jrb.myu_s = 0.5;
  jrb.myu_k = 0.4;
  const double thickness = 0.012;
//  const double thickness = 0.018;  
  const double density = 300;
  jrb.lenz = thickness;
  jrb.rho = density;
  jrb.invstiff_pos = 1.0e-5;
  jrb.invstiff_rot = 1.0e-5;    
  
  const double PI = 3.1415;
      
  if( iprob == 0 ){
    /*
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,0.0);            
      jrb.AddRigidBody_Box(0.3,0.5,thickness, density, Com::CVector3D(+0.0,0.1,0), m );    
//      jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(0.0,-10.0,0) );  // 10kg        
    }
     */
  }      
  if( iprob == 1 ){
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,0.0);      
      jrb.AddRigidBody_Box(0.2,0.1,thickness, density, Com::CVector3D(+0.0,+0.4,0.0),m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5,0,PI*0.5+PI*0.1);
      jrb.AddRigidBody_Box(0.2,0.1,thickness, density, Com::CVector3D(+0.1,+0.3,0.0),m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5,0,PI*0.5-PI*0.1);      
      jrb.AddRigidBody_Box(0.2,0.1,thickness, density, Com::CVector3D(-0.1,0.3,+0.0), m);
    }
    double invstiff_pos = 1.0e-5, invstiff_rot = 1.0e-5;
    Com::CVector3D ex(1,0,0), ey(0,1,0), ez(0,0,1);
    jrb.AddFixJoint(1,0, 5,0, Com::CVector3D(+0.2,+0.4,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);
    jrb.AddFixJoint(2,0, 4,1, Com::CVector3D(-0.2,+0.4,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);
//    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(0.0,-density.0,0) );  // 30kg
    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(0.0,-100.0,0) );  // 10kg        
    //    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(0,0,-0.5) );    
  }
  if( iprob == 2 ){
    ////
    double phi = -10*3.1415/180.0;
    double hight = 1.2;
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,0);
      jrb.AddRigidBody_Box(0.5,0.5,thickness, 1, Com::CVector3D(1.0, +0.75, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5, 0,  PI*0.5+phi);
      jrb.AddRigidBody_Box(0.5,0.5,thickness, 1, Com::CVector3D(1.3, +0.8*0.5, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5,  0, PI*0.5-phi); 
      jrb.AddRigidBody_Box(0.5,0.5,thickness, 1, Com::CVector3D(0.7, +0.8*0.5, 0), m);
    }
    double invstiff_pos = 1.0e-5, invstiff_rot = 1.0e-5;    
    Com::CVector3D ex(1,0,0), ey(0,1,0), ez(0,0,1);
    jrb.AddFixJoint(0,1, 4,0, Com::CVector3D(1.3,+0.8,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);
    jrb.AddFixJoint(0,2, 4,0, Com::CVector3D(0.7,+0.8,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);    
//    jrb.AddExternalForce(0, Com::CVector3D(0,0,0s), Com::CVector3D(0.0,-6,0) );
    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(-0.0,-300,0) );            
    for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
      if( irb == 0 ) continue;      
      /*
      aOptDof.push_back( COptimizationDof(BOX_POS,irb,0) );
      aOptDof.push_back( COptimizationDof(BOX_POS,irb,1) );      
      aOptDof.push_back( COptimizationDof(BOX_ROT,irb,2) );
      aOptDof.push_back( COptimizationDof(BOX_LEN,irb,0) );
       */
    }
    /*
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,0) );
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,1) );        
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,2) );      
    } 
     */
/*    
    {
      Com::CVector3D b(1,0,0), n(1,0,0);
      aOptDof.push_back( COptimizationDof(BOX_POS,1,0, 2,0) );
      aOptDof.push_back( COptimizationDof(BOX_POS,1,1, 2,0) );      
      aOptDof.push_back( COptimizationDof(BOX_ROT,1,2, 2,0) );
//      aOptDof.push_back( COptimizationDof(BOX_LEN,irb,0) );
    } */   
    /*
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,0) );
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,1) );            
    } 
     */
  }
  if( iprob == 3 ){
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,0);
      jrb.AddRigidBody_Box(0.4,0.4,thickness, density, Com::CVector3D(+0.0, +0.5, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,+2.0);
      jrb.AddRigidBody_Box(0.4,0.4,thickness, density, Com::CVector3D(+0.3, 0.3, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,-2.0);            
      jrb.AddRigidBody_Box(0.4,0.4,thickness, density, Com::CVector3D(-0.3, 0.3, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(3.1415*0.5,0,+2.0);                  
      jrb.AddRigidBody_Box(0.4,0.4,thickness, density, Com::CVector3D(-0.3, 0.8, 0), m);
    }
    double invstiff_pos = 1.0e-5, invstiff_rot = 1.0e-5;    
    Com::CVector3D ex(1,0,0), ey(0,1,0), ez(0,0,1);
    jrb.AddFixJoint(0,1, 4,0, Com::CVector3D(+0.2,+0.5,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);
    jrb.AddFixJoint(0,2, 4,1, Com::CVector3D(-0.2,+0.5,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);    
    jrb.AddFixJoint(0,3, 5,1, Com::CVector3D(-0.1,+0.5,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);    
    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(-0.0,-300,0) );        
//    jrb.AddExternalForce(0, Com::CVector3D(0,0,0), Com::CVector3D(-0.5,0,0) );
    /*
    for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
      aOptDof.push_back( COptimizationDof(BOX_POS,irb,0) );
      if( irb != 0 ){    
        aOptDof.push_back( COptimizationDof(BOX_POS,irb,1) );      
      }
      aOptDof.push_back( COptimizationDof(BOX_ROT,irb,2) );
      if( irb == 1 || irb == 2 ){
        aOptDof.push_back( COptimizationDof(BOX_LEN,irb,0) );
      }
    }
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,0) );
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,1) );
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,2) );      
    } 
     */
  }
  if( iprob == 4 ){ // bookshelf
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5,0,0);
      jrb.AddRigidBody_Box(0.4, 0.4, thickness, density, Com::CVector3D(0.0, +0.6, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5, 0.0, PI*0.5-0.1);      
      jrb.AddRigidBody_Box(0.8, 0.4, thickness, density, Com::CVector3D(+0.2, +0.4, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5, 0.0, PI*0.5-0.15);      
      jrb.AddRigidBody_Box(0.8, 0.4, thickness, density, Com::CVector3D(-0.2, +0.4, 0), m);
    }
    {
      Com::CMatrix3 m; m.SetRotMatrix_BryantAngle(PI*0.5,0,0);      
      jrb.AddRigidBody_Box(0.4, 0.4, thickness, density, Com::CVector3D(0.0, +0.3, 0), m);
    }
    double invstiff_pos = 1.0e-5, invstiff_rot = 1.0e-5;
    Com::CVector3D ex(1,0,0), ey(0,1,0), ez(0,0,1);
    jrb.AddFixJoint(1,0, 5,0, Com::CVector3D(+0.2,+0.6,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);
    jrb.AddFixJoint(2,0, 4,1, Com::CVector3D(-0.2,+0.6,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);    
    jrb.AddFixJoint(1,3, 5,0, Com::CVector3D(+0.2,+0.3,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);        
    jrb.AddFixJoint(2,3, 4,1, Com::CVector3D(-0.2,+0.3,+0.0), ex,ey,ez, invstiff_pos,invstiff_rot);        
    jrb.AddExternalForce(3, Com::CVector3D(0,0,0), Com::CVector3D(-0.0,-300,0) );    
    /*
    for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
      aOptDof.push_back( COptimizationDof(BOX_POS,irb,0) );
      if( irb != 0 && irb != 3 ){
        aOptDof.push_back( COptimizationDof(BOX_POS,irb,1) );      
      }
      aOptDof.push_back( COptimizationDof(BOX_ROT,irb,2) );
      aOptDof.push_back( COptimizationDof(BOX_LEN,irb,0) );
    }
    for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,0) );
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,1) );            
      aOptDof.push_back( COptimizationDof(JNT_POS,ifix,2) );      
    } 
     */
  }    
  
  camera_des.SetRotAxis(1);    
  if( jrb.aRI.size() == 0 ){
    Com::CBoundingBox3D bb(-0.3,0.3, -0.3,0.3, -0.3,0.3);
    camera_des.Fit(bb);
  }
  else{
    camera_des.Fit(jrb.GetBoundingBox(false));    
  }
  ::glutSetWindow(iwin_des);  
  ::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
  Com::View::SetProjectionTransform(camera_des);
  
  for(unsigned int i=0;i<1000;i++){
    double dt = 0.01;
    double resn, updn;
    StepTime_BackwardEular(jrb,dt,resn,updn);	// solve rigid motion
  }
  FindInitialConfiguration_SameFrictionAnchor(jrb);
  jrb.PlaceNails();
  

  
//  ::glutSetWindow(iwin_des);
  camera_sim.SetRotAxis(1);
  camera_sim.Fit(jrb.GetBoundingBox(true));
  ::glutSetWindow(iwin_sim);  
  ::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
  Com::View::SetProjectionTransform(camera_sim);  
  
  jrb_pre = jrb;
  iprob++;
  if( iprob == nprob ) iprob = 0;
}

  





void myGlutKeyboard(unsigned char key, int x, int y)
{
  unsigned int nRB = jrb.aRI.size();
  unsigned int naFix = jrb.aFix.size();
  switch (key) {
    case '1':
    {
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        const CRigid3D_Ini& ri = jrb.aRI[irb];
        std::cout << irb << " " << ri.xlen << " " << ri.ylen << std::endl;
      }      
      for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
        const CJoint_Fix& fix = jrb.aFix[ifix];
        const Com::CVector3D& jp = fix.ini_pos_joint;
        unsigned int irb0 = fix.irb0; const CRigid3D_Ini& ri0 = jrb.aRI[irb0];
        unsigned int irb1 = fix.irb1; const CRigid3D_Ini& ri1 = jrb.aRI[irb1];
        const Com::CVector3D& p0 = ri0.GetRotMatrix_Ini().MatVecTrans(jp-ri0.ini_pos_cg);
//        const Com::CVector3D& p1 = ri1.GetRotMatrix_Ini().MatVecTrans(jp-ri1.ini_pos_cg);        
        std::cout << ifix << "   irb0:" << irb0  << "   irb1 " << irb1 << std::endl;
        const CNailJoint& nj = jrb.aNailJoint[ifix];
        for(unsigned int inj=0;inj<nj.aPosHead.size();inj++){
          const Com::CVector3D& p1 = nj.aPosHead[inj];
          const Com::CVector3D& p0 = ri0.GetRotMatrix_Ini().MatVecTrans(p1-ri0.ini_pos_cg);          
          std::cout << "   " << inj << " " << p0 << std::endl;
        }
      }
      /*
      const Com::CVector3D aFaceNormal[6] = {
        Com::CVector3D(+1, 0, 0),
        Com::CVector3D(-1, 0, 0),
        Com::CVector3D(+0,+1, 0),
        Com::CVector3D(-0,-1, 0),
        Com::CVector3D(+0, 0,+1),
        Com::CVector3D(-0, 0,-1) };     
      for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
        const CJoint_Fix& cst = jrb.aFix[ifix];
        const CJoint_Fix_Force& jff = jrb.aJFixForce[ifix];
        unsigned int idir1 = jrb.aFixDir[ifix].second;   
        Com::CVector3D pos_force(jff.lambda[0],jff.lambda[1],jff.lambda[2]); 
        Com::CVector3D bnd_force(jff.lambda[3],jff.lambda[4],jff.lambda[5]); 
        const CNailJoint& nj = jrb.aNailJoint[ifix];
        const double lennail = nj.lennail;
        const CRigid3D_Ini& ri1 = jrb.aRI[cst.irb1];
        const Com::CMatrix3& Q1 = ri1.GetRotMatrix_Ini();
        const Com::CVector3D& Qh1 = Q1.MatVec( Cross( Com::CVector3D(0,0,1), aFaceNormal[idir1] ) );      
//        std::cout << Qh1 << "    " << bnd_force << std::endl;
      }
       */
    }
      break;
    case '2':
      jrb.writeFile("hoge.dat");
      break;
    case '3':
      jrb.loadFile("hoge.dat");
      break;
    case '4':
    {
      char fname[256];
      scanf("%s",fname);
      std::string str(fname);
      bool res = jrb.loadFile(str);
      if( !res ) break;
      isgg_hover = -1;
      aSggJRB.clear();
      aDesModeBound.clear();
      if( jrb.aRI.size() == 0 ){
        Com::CBoundingBox3D bb(-0.3,0.3, -0.3,0.3, -0.3,0.3);
        camera_des.Fit(bb);
      }
      else{
        camera_des.Fit(jrb.GetBoundingBox(false));    
      }
      ::glutSetWindow(iwin_des);  
      ::glMatrixMode(GL_PROJECTION);
      ::glLoadIdentity();
      Com::View::SetProjectionTransform(camera_des);      
      break;
    }
    case '5':
    {
      PrintOutForceSpace(jrb.aRI, jrb.aRD, 
                         jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
                         ////
                         jrb.gravity, jrb.contProp, jrb.aFP);          
      break;
    }
    case '6':
    {
      std::cout << "make the plank thick" << std::endl;
      for(unsigned int inj=0;inj<jrb.aNailJoint.size();inj++){
        CNailJoint& nj = jrb.aNailJoint[inj];
        nj.lennail = 0.045;
        nj.dia_head = 0.0058;
        nj.intervnail = nj.dia_head*5; // 2cm
        nj.shear_max = 30.0*10.0; // per newton
        nj.pull_max_perlen = 4.5*100*10.0;  // 4kg/cm = 4000N/m      
      }
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        CRigid3D_Ini& ri = jrb.aRI[irb];
        ri.zlen = 0.018;        
      }
      jrb.lenz = 0.018;
    }
      break;
    case '7':
    {
      std::cout << "make the plank thick" << std::endl;
      for(unsigned int inj=0;inj<jrb.aNailJoint.size();inj++){
        CNailJoint& nj = jrb.aNailJoint[inj];
        nj.lennail = 0.032;
        nj.dia_head = 0.0045;
        nj.intervnail = 0.02; // 2cm
        nj.shear_max = 19.0*10.0; // per newton
        nj.pull_max_perlen = 3.5*100*10.0;  // 4kg/cm = 4000Nm  
      }
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        CRigid3D_Ini& ri = jrb.aRI[irb];
        ri.zlen = 0.012;        
      }
      jrb.lenz = 0.012;
    }
      break;
    case '9':
      {
        jrb.aFix.clear();
        jrb.aJFixForce.clear();
        jrb.aNailJoint.clear();
        jrb.aFixDir.clear();
        /*
        jrb.aFix.resize(jrb.aFix.size()-1);
        jrb.aJFixForce.resize(jrb.aJFixForce.size()-1);
        jrb.aNailJoint.resize(jrb.aNailJoint.size()-1);        
         */
      }
      imode_userstudy = 5;
      break;      
    case '0':      
      is_show_feedback = !is_show_feedback;
      if( is_show_feedback ){
        SolveStaticEquilibrium(jrb.aRI,jrb.aRD,jrb.aFix,jrb.aJFixForce,jrb.aExForce,
                               jrb.gravity,
                               jrb.contProp,
                               jrb.aFP);                  
      }
      else{
        if( imode_userstudy == 0 ){
          for(unsigned int ifix=0;ifix<jrb.aJFixForce.size();ifix++){            
            for(unsigned int i=0;i<6;i++){
              jrb.aJFixForce[ifix].lambda[i] = 0;
            }
          }
        }        
      }
      break;
    case '-':
      jrb.writeFileObj("hoge.obj");
      break;
    case '\033':
      if( imode_system == 2 ){  // add plank mode
        nPosAddPlank = 0;
      }
      break;
    case 'q':
    case 'Q':
      exit(0);
      break;
    case 'a':
      is_animation = !is_animation;
      break;
    case 'b':
      jrb.ClearValue();
      break;
    case 'c':
      jrb.Clear();
      break;
    case 'd': // duplicate
    { 
      if( ind_picked_obj >= 0 && ind_picked_obj < jrb.aRI.size() ){        
        unsigned int irb0 = ind_picked_obj;
        CRigid3D_Ini ri = jrb.aRI[irb0];
        const double zlen = ri.zlen;
        Com::CVector3D n = ri.GetRotMatrix_Ini().MatVec( Com::CVector3D(0,0,1) );
        {
          Com::CVector3D src,dir;
          camera_des.GetRayVerticalScreen(0, 0, src, dir);
          if( Dot(n,dir) < 0 ){ n *= -1; }
        }
        ri.SetIniPosCG( ri.GetIniPosCG() + zlen*3*n );
        unsigned int irb_add = jrb.AddRigidBody();
        jrb.aRI[irb_add] = ri;
        ind_picked_obj = irb_add;
        for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
          const CJoint_Fix& fix = jrb.aFix[ifix];
          unsigned int idir0 = jrb.aFixDir[ifix].first;
          unsigned int idir1 = jrb.aFixDir[ifix].second;          
          if( fix.irb0 == irb0 && 
             (idir0 != 4 || idir0 != 5 ) && 
             (idir1 == 4 || idir1 == 5 ) )
          {
            unsigned int ifix_add = jrb.AddFixJoint(irb_add, fix.irb1,
                                                    idir0,idir1,
                                                    fix.ini_pos_joint + zlen*3*n,
                                                    Com::CVector3D(1,0,0), Com::CVector3D(0,1,0), Com::CVector3D(0,0,1),
                                                    fix.invstiff_pos, fix.invstiff_rot);                                                                                                        
          }
          if( fix.irb1 == irb0 && 
             (idir1 != 4 || idir1 != 5 ) && 
             (idir0 == 4 || idir0 == 5 ) )
          {
            unsigned int ifix_add = jrb.AddFixJoint(fix.irb0, irb_add,
                                                    idir0,idir1,
                                                    fix.ini_pos_joint + zlen*3*n,
                                                    Com::CVector3D(1,0,0), Com::CVector3D(0,1,0), Com::CVector3D(0,0,1),
                                                    fix.invstiff_pos, fix.invstiff_rot);                                                                                                        
          }          
        }
        { // set is_force_flag
          CContactPoints_RigidBody3D& aCP = jrb.aFP[irb_add];
          for(unsigned int i=0;i<aCP.Size();i++){
            const CRigid3D_Ini& ri = jrb.aRI[irb_add];
            Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);         
            Com::CVector3D v1 = ri.GetInitialPosition(v0);
            double pd = Com::Dot(jrb.contProp.cont_base-v1,jrb.contProp.cont_norm);
            if( pd > -jrb.lenz*0.1 ){
              aCP.aFP[i].is_force_cont = true;
            }
          } 
        }
        EnforceContact_ChangeBoxLen(jrb.aRI,jrb.aFP,jrb.contProp.cont_norm,jrb.contProp.cont_base);        
        EnforceJointConnectivity_ChangeBoxLen(jrb.aRI, jrb.aFix, jrb.aFixDir);  
        jrb.PlaceNails();
        desModeBound.irb0 = -1;
        aDesModeBound.clear();
        aSggJRB.clear();
        simSens.Initialize(jrb.aRI.size(),jrb.aFix.size());
      }
    }
    case 'e':
      TestContact();
      TestStaticFriction();
      TestKineticFriction();
      break;
    case 'f':
      TestContact_RigidPointSet();      
      TestStaticFriction_RigidPointSet();
      break;
    case 'g':
      TestSensitiveResidual(jrb, JNT_POS,1,0,MOVE_INITIAL);
      break; 
    case 'h':
      for(unsigned int irb=0;irb<jrb.aRI.size();irb++){
        const CRigid3D_Ini& ri = jrb.aRI[irb];
        CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
        for(unsigned int i=0;i<aCP.Size();i++){
          if( !aCP.aFP[i].is_force_cont ) continue;    
          Com::CVector3D v0 = aCP.GetPosContactPoint(i,ri.xlen,ri.ylen,ri.zlen);            
          Com::CVector3D v1 = ri.GetInitialPosition(v0);
          aCP.aFP[i].aloc = v1;
        }   
      }  
      SolveStaticEquilibrium(jrb.aRI,jrb.aRD,jrb.aFix,jrb.aJFixForce,jrb.aExForce,
                             jrb.gravity,
                             jrb.contProp,
                             jrb.aFP);  
      break;
    case 'i':
      TestSensitiveResidual(jrb, JNT_POS,1,0,DONT_MOVE);
      break;      
    case 'j':
      TestSensitiveResidual(jrb, JNT_POS,1,0,MOVE_TOGETHER);      
      break;            
    case 'k':
      JointConnectivityEnforcement_ChangeBoxLen(jrb);      
      ContactEnforcement_ChangeBoxLen(jrb);      
      break;      
    case 'l':
      JointConnectivityEnforcement_ChangeBoxPosRotLen(jrb);
      break;
    case 'm':
      TestSensitive_JointConnectivityEnergy();
      break;
    case 'n':
      for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
        if( !CheckJointInside(ifix,jrb.aRI,jrb.aFix,jrb.aFixDir) ){
          FlipJoint(ifix,jrb.aRI,jrb.aFix,jrb.aFixDir);
        }
      }
      break;      
    case 'o':
      Optimize_GradModes
      (1.0e-5,
       jrb.aRI,  jrb.aRD,                                        
       jrb.aFix, jrb.aJFixForce, jrb.aFixDir, 
       jrb.aExForce,
       ////
       jrb.gravity, jrb.contProp, jrb.aFP);      
      break;
    case 'p':
    {
//      std::vector<CDesignSensitivity> aDesMode;
      /*
      GetBendingInvariantModes
      (aDesMode,
       jrb.aRI, jrb.aRD, 
       jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aExForce,
       ////
       jrb.gravity, jrb.contProp, jrb.aFP);  
       */
      jrb_pre = jrb;
      if( imode_system != 1 ){ imode_system = 1; }
      else{ imode_system = 0; rigid_edit_mode = -1; }      
      /*
      GetSuggestionModes
      (aDesModeBound,
       jrb.aRI, jrb.aRD, 
       jrb.aFix, jrb.aJFixForce, jrb.aFixDir, jrb.aNailJoint, jrb.aExForce,
       ////
       jrb.gravity, jrb.contProp, jrb.aFP);        
      aSggJRB.resize(aDesModeBound.size(),jrb);
       */
//      aDesModeBound.resize(aDesMode.size());
      /*
      for(unsigned int imo=0;imo<aDesMode.size();imo++){
        aDesModeBound[imo].desMode = aDesMode[imo];
        double tmin=-0.3, tmax=+0.3;
        FindRangeSoundStructure_Bisec
        (tmin, tmax,
         aDesMode[imo],
         jrb.aRI, jrb.aFix,jrb.aFixDir,
         jrb.gravity,jrb.contProp,
         ////
         jrb.aFP,jrb.aExForce,
         jrb.aNailJoint);                
       */
        /*
        FindJointInsidePlankRange
        (tmin, tmax,
         aDesMode[imo],
         jrb.aRI,
         jrb.aFix,
         jrb.aFixDir);
        FindTopplingRange
        (tmin, tmax,
         aDesMode[imo],
         jrb.aRI,jrb.aFix,jrb.aFixDir,
         jrb.gravity,jrb.contProp,
         jrb.aRD,jrb.aJFixForce,jrb.aFP,jrb.aExForce);        
        double tmin0=tmin,tmax0=tmax;
        CSimulationSensitivity simSens;
        GetJointStabilityRange
        (tmin0, tmax0,
         aDesMode[imo],
         jrb.aRI, jrb.aFix,jrb.aFixDir,
         jrb.gravity,jrb.contProp,
         ////
         simSens,
         jrb.aRD,jrb.aJFixForce,jrb.aFP,jrb.aExForce,
         jrb.aNailJoint);        
        if( tmin0 < tmax0 && tmin0<tmax && tmax0>tmin){
          tmin = (tmin>tmin0) ? tmin : tmin0;
          tmax = (tmax<tmax0) ? tmax : tmax0;
        }
         */
//        aDesModeBound[imo].tmin = tmin;        
//        aDesModeBound[imo].tmax = tmax;          
//      }
    }
      break; 
    case 'r':
      for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
        double shear, pull;
        DisplayJointCapacity(ifix, shear, pull,
                             jrb.aRI, jrb.aRD, 
                             jrb.aFix, 
                             jrb.aJFixForce, 
                             jrb.aFixDir, 
                             jrb.aNailJoint);
        std::cout << ifix << "   shear : " << shear*100 << "    pull : " << pull*100 << std::endl;               
      }
      break;                  
    case 's':
//      aSggJRB.resize(1,jrb);
//      MakeSuggestionSupportMaterial(aSggJRB[0]);
      MakeSuggestionSupportMaterial2(jrb,aSggJRB);
      break;
    case 't':
      TestSensitive_PRLJ(jrb, BOX_POS,1,1,MOVE_INITIAL);      
      TestSensitive_PRLJ(jrb, BOX_ROT,1,2,MOVE_INITIAL);      
      TestSensitive_PRLJ(jrb, BOX_LEN,1,0,MOVE_INITIAL);            
      TestSensitive_PRLJ(jrb, JNT_POS,1,0,MOVE_INITIAL);            
      
      break;
    case 'u':
//      TestSensitive_PRLJ(jrb, BOX_POS,1,1,DONT_MOVE);
    {
      CDesignSensitivity desSens;
      unsigned int irb=1;
      unsigned int imo=4;
      int icont_flg = 0;      
      {
        const CContactPoints_RigidBody3D& aCP = jrb.aFP[irb];
        if( aCP.aFP[1].is_force_cont && aCP.aFP[2].is_force_cont ){ icont_flg += 1; } // +x    
        if( aCP.aFP[3].is_force_cont && aCP.aFP[0].is_force_cont ){ icont_flg += 2; } // -x
        if( aCP.aFP[2].is_force_cont && aCP.aFP[3].is_force_cont ){ icont_flg += 4; } // +y        
        if( aCP.aFP[0].is_force_cont && aCP.aFP[1].is_force_cont ){ icont_flg += 8; } // -y
        int ijnt_flg = 0;
        for(unsigned int ifix=0;ifix<jrb.aFix.size();ifix++){
          unsigned int irb0 = jrb.aFix[ifix].irb0;
          unsigned int irb1 = jrb.aFix[ifix].irb1;      
          unsigned int idir0 = jrb.aFixDir[ifix].first;
          unsigned int idir1 = jrb.aFixDir[ifix].second;
          if( irb0 != irb && irb1 != irb ) continue;
          unsigned int idir2 = ( irb0 == irb ) ? idir0 : idir1;
          if( idir2 == 0 ){ ijnt_flg = ijnt_flg | 1; } // +x
          if( idir2 == 1 ){ ijnt_flg = ijnt_flg | 2; } // -x
          if( idir2 == 2 ){ ijnt_flg = ijnt_flg | 4; } // +y
          if( idir2 == 3 ){ ijnt_flg = ijnt_flg | 8; } // -y      
        }
      }
      GetDesignSensitivity(desSens, jrb.aRI,jrb.aFix,jrb.aFixDir,irb, imo, icont_flg,jrb.contProp);
      TestSensitive_PRLJ(jrb,desSens);
//      TestSensitiveResidual(jrb, desSens);
    }
      break;      
    case 'v':
      FindInitialConfiguration_SameFrictionAnchor(jrb);
      jrb.PlaceNails();
      break;            
    case 'w':
//      OptimizeEvalFunc_GradMultDirPrj(jrb, 3.0e-10,aOptDof,0,0);
      break;
    case 'x':
//      ItrOptimizeEvalFunc_GradMultDir(jrb,1.0e-9,aOptDof,0,0);
      break;
    {
      std::cout << "######################" << std::endl;      
      std::cout << "OptimizeEvalFunc_Grad" << std::endl;
      double eps = 1.0e-7;
      ANCHOR_RELOCATION_TYPE itype_anchor_reloc = MOVE_INITIAL;
      for(unsigned int irb=0;irb<nRB;irb++){      
        OptimizeEvalFunc_Grad(jrb, BOX_POS,irb,0, eps, itype_anchor_reloc);
        OptimizeEvalFunc_Grad(jrb, BOX_POS,irb,1, eps, itype_anchor_reloc);
        ////
        OptimizeEvalFunc_Grad(jrb, BOX_ROT,irb,2, eps, itype_anchor_reloc);
        ///
        OptimizeEvalFunc_Grad(jrb, BOX_LEN,irb,0, eps, itype_anchor_reloc);
        OptimizeEvalFunc_Grad(jrb, BOX_LEN,irb,1, eps, itype_anchor_reloc);
      }
      for(unsigned int ifix=0;ifix<naFix;ifix++){
        OptimizeEvalFunc_Grad(jrb, JNT_POS,ifix,0, eps, itype_anchor_reloc);
        OptimizeEvalFunc_Grad(jrb, JNT_POS,ifix,1, eps, itype_anchor_reloc);
      }
      break;
    }      
    case 'y':
//      OptimizeEvalFunc_GradPrj(jrb, 3.0e-10,aOptDof);
      break;
    case 'z':      
//      ItrOptimizeEvalFunc_Grad(jrb, 5.0e-7,aOptDof,0,0);
      break;
    case ' ':
      SetNewProblem();
    default:
      break;
  }
//  is_converged = false;
}

void myGlutSpecialFunc(int key, int x, int y){
  if( glutGetWindow() == iwin_des ){
    switch(key){
      case GLUT_KEY_PAGE_UP :           
        camera_des.SetScale( camera_des.GetScale()*0.9    );
        break;
      case GLUT_KEY_PAGE_DOWN :
        camera_des.SetScale( camera_des.GetScale()*1.1111 );
        break;
      case GLUT_KEY_UP :           
      {
        double theta, phi;
        camera_des.GetRotation2DH(theta, phi);
        phi += 10*3.1415*2/360.0;
        camera_des.SetRotation2DH(theta, phi);
        break;        
      }
      case GLUT_KEY_DOWN :       
      {
        double theta, phi;
        camera_des.GetRotation2DH(theta, phi);
        phi -= 10*3.1415*2/360.0;
        camera_des.SetRotation2DH(theta, phi);
        break;        
      }        
      case GLUT_KEY_LEFT :           
      {
        double theta, phi;
        camera_des.GetRotation2DH(theta, phi);
        theta += 10*3.1415*2/360.0;
        camera_des.SetRotation2DH(theta, phi);
        break;        
      }
      case GLUT_KEY_RIGHT :       
      {
        double theta, phi;
        camera_des.GetRotation2DH(theta, phi);
        theta -= 10*3.1415*2/360.0;
        camera_des.SetRotation2DH(theta, phi);
        break;        
      }                
    }            
    ::glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    Com::View::SetProjectionTransform(camera_des);        
  }
  else if( glutGetWindow() == iwin_sim ){
    switch(key){
      case GLUT_KEY_PAGE_UP :           
        camera_sim.SetScale( camera_sim.GetScale()*0.9    );
        break;
      case GLUT_KEY_PAGE_DOWN :
        camera_sim.SetScale( camera_sim.GetScale()*1.1111 );
        break;
    }    
    ::glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    Com::View::SetProjectionTransform(camera_sim);    
  }
}

bool ReadPNMTexture(const std::string& fname, 
                    unsigned int& texName, 
                    unsigned int& texWidth, unsigned int& texHeight)
{
  std::cout << "ReadPPM " << std::endl;
  FILE* fp = fopen(fname.c_str(),"r");
  if( fp == NULL ){ 
    std::cout << "Read PPM Fail" << std::endl;
    return false; 
  }
  
  int w, h;
  std::vector<char> aRGB;
  {
    const unsigned int buffSize = 256;
    char buff[buffSize];
    fgets(buff,buffSize,fp);
    for(;;){
      fgets(buff,buffSize,fp);      
      if( buff[0] != '#' ) break;
    }
    sscanf(buff,"%d%d",&w,&h);			
    fgets(buff,buffSize,fp);  // read 255
  }
  std::cout << "tex size : " << w << " " << h << std::endl;
  assert( w >= 0 && h >=0 );
  aRGB.resize(w*h*3);
  const unsigned int buffSize = (unsigned int)(4*3*w*1.2);	// ÇøÇÂÇ¡Ç∆ó]ï™ñ⁄Ç…Ç∆Ç¡ÇƒÇ®Ç≠
  char* buff = new char [buffSize];
  unsigned int icnt = 0;
  while (icnt<w*h*3) {
    fgets(buff,buffSize,fp);
    char* pCur = buff;
    char* pNxt;
    for(;;){
      if(      pCur[0] == ' ' ){ assert(0); }
      if(      pCur[1] == ' ' || pCur[1] == '\n' ){ pCur[1]='\0'; pNxt=pCur+2; }
      else if( pCur[2] == ' ' || pCur[2] == '\n' ){ pCur[2]='\0'; pNxt=pCur+3; }
      else if( pCur[3] == ' ' || pCur[3] == '\n' ){ pCur[3]='\0'; pNxt=pCur+4; }
      else{ assert(0); }
      unsigned int val = atoi(pCur);
      unsigned int ih = icnt/(w*3);
      unsigned int iw = icnt-ih*w*3;
      aRGB[(h-ih-1)*w*3+iw] = val;
      icnt++;
      if( pNxt[0] == '\n' || pNxt[0] == '\0') break;
      pCur = pNxt;
    }
  }
  delete[] buff;
  //	this->SetImage(w,h,aRGB);
  
  std::cout << "width height : " << w << " " << h << std::endl;
  
  ////////////////
  
  // 255 : non-transparent
  // 0   : transparent
  GLubyte* inputRGBA = new GLubyte [w*h*4];
  char min_trans = 128;
  for(unsigned int i=0;i<w*h;i++){ 
    inputRGBA[i*4+0] = aRGB[i*3+0]; 
    inputRGBA[i*4+1] = aRGB[i*3+1]; 
    inputRGBA[i*4+2] = aRGB[i*3+2];     
//    std::cout << aRGB[i*3+0] << " " << aRGB[i*3+1] << " " << aRGB[i*3+2] << std::endl;
    if( aRGB[i*3+0] == (char)255 && aRGB[i*3+1] == (char)255 && aRGB[i*3+2] == (char)255 ){ // white is transparent
      inputRGBA[i*4+3] = min_trans;
    }    
    else if( aRGB[i*3+0] == aRGB[i*3+1] && aRGB[i*3+0] == aRGB[i*3+2] && aRGB[i*3+2] != (char)255 ){ // gray
      inputRGBA[i*4+0] = 0;
      inputRGBA[i*4+1] = 0;
      inputRGBA[i*4+2] = 0;            
      char trans = 255-aRGB[i*3+0];
      inputRGBA[i*4+3] = (trans < min_trans) ? min_trans : trans;
    }
    else if( aRGB[i*3+0] != aRGB[i*3+1] && aRGB[i*3+1] == aRGB[i*3+2] ){ // red
//    else{
//      std::cout << aRGB[i*3+0] << " " << aRGB[i*3+1] << " " << aRGB[i*3+2] << std::endl;
      inputRGBA[i*4+0] = 255;
      inputRGBA[i*4+1] = 0;
      inputRGBA[i*4+2] = 0;       
      char trans = 255-aRGB[i*3+1];
      inputRGBA[i*4+3] = (trans < min_trans) ? min_trans : trans;
    } 
    else if( aRGB[i*3+2] != aRGB[i*3+0] && aRGB[i*3+0] == aRGB[i*3+1] ){ // red
      //    else{
      //      std::cout << aRGB[i*3+0] << " " << aRGB[i*3+1] << " " << aRGB[i*3+2] << std::endl;
      inputRGBA[i*4+0] = 0;
      inputRGBA[i*4+1] = 0;
      inputRGBA[i*4+2] = 255;       
      char trans = 255-aRGB[i*3+0];
      inputRGBA[i*4+3] = (trans < min_trans) ? min_trans : trans;
    }        
    /*
    else{ // transparent
      inputRGBA[i*4+0] = 0;
      inputRGBA[i*4+1] = 0;
      inputRGBA[i*4+2] = 0;      
      inputRGBA[i*4+3] = 255;      
    }
     */
  }
  
  texWidth = 1;    
  for(;;){
    if( w <= texWidth ) break;
    texWidth *= 2;
  }    
  ////
  texHeight = 1;    
  for(;;){
    if( w <= texHeight ) break;
    texHeight *= 2;
  }          
  
  GLubyte* scaledRGBA;
  if( w == texWidth && h == texHeight ){
    scaledRGBA = inputRGBA;
  }
  else{
    scaledRGBA = new GLubyte [texWidth*texHeight*4];
    gluScaleImage( GL_RGBA, w, h, GL_UNSIGNED_BYTE, inputRGBA,
                  texWidth, texHeight, GL_UNSIGNED_BYTE, scaledRGBA );
    delete [] inputRGBA;
  }
  
  glEnable(GL_TEXTURE_2D);
  glGenTextures(1 , &texName);
  glBindTexture(GL_TEXTURE_2D , texName);
  glTexImage2D(GL_TEXTURE_2D , 0 , 4 , texWidth, texHeight,
               0 , GL_RGBA , GL_UNSIGNED_BYTE , scaledRGBA );
  delete[] scaledRGBA;
  return true;
}

int main(int argc,char* argv[])
{  

  ::glutInit(&argc, argv);
  
  
  // Simulation window
  ::glutInitWindowPosition(510,100);
  ::glutInitWindowSize(400,600);
  ::glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
  iwin_sim = glutCreateWindow("Simulation Window");
  ::glutMotionFunc(myGlutMotion);
	::glutMouseFunc(myGlutMouse);
	::glutDisplayFunc(myGlutDisplay);
	::glutReshapeFunc(myGlutResize);
	::glutKeyboardFunc(myGlutKeyboard);
  ::glutSpecialFunc(myGlutSpecialFunc);
	::glutIdleFunc(myGlutIdle);  
  {
    ::glutSetWindow(iwin_sim);
    ////
    ::glEnable(GL_LIGHTING);
    ::glEnable(GL_LIGHT0);            
    float light0pos[4] = {0,10,+20,0};
    ::glLightfv(GL_LIGHT0, GL_POSITION, light0pos);      
    float white[3] = {0.8,0.8,0.8};
    ::glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
    
    ::glEnable(GL_LIGHT1);    
    float light1pos[4] = {3,10,+10,0}; 
    ::glLightfv(GL_LIGHT1, GL_POSITION, light1pos);          
    float white2[3] = {0.4,0.4,0.4};
    ::glLightfv(GL_LIGHT1, GL_DIFFUSE, white2);        
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
  } 
  glutHideWindow();
    
  // Design window
  ::glutInitWindowPosition(310,100);
  ::glutInitWindowSize(600,600);
  ::glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
  iwin_des = glutCreateWindow("Design window");
  ::glutMotionFunc(myGlutMotion);
	::glutMouseFunc(myGlutMouse);
	::glutDisplayFunc(myGlutDisplay);
	::glutReshapeFunc(myGlutResize);
	::glutKeyboardFunc(myGlutKeyboard);
  ::glutSpecialFunc(myGlutSpecialFunc);
	::glutIdleFunc(myGlutIdle);  
  ::glutPassiveMotionFunc(myGlutPassiveMotion);
  {
    ::glutSetWindow(iwin_des);    
    ////
    ::glEnable(GL_LIGHTING);
    ::glEnable(GL_LIGHT0);            
    float light0pos[4] = {0,10,+20,0};
    ::glLightfv(GL_LIGHT0, GL_POSITION, light0pos);      
    float white[3] = {0.8,0.8,0.8};
    ::glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
    
    ::glEnable(GL_LIGHT1);    
    float light1pos[4] = {-3,5,+10,0}; 
    ::glLightfv(GL_LIGHT1, GL_POSITION, light1pos);          
    float white2[3] = {0.4,0.4,0.4};
    ::glLightfv(GL_LIGHT1, GL_DIFFUSE, white2);        
    ::glEnable(GL_BLEND);
    ::glEnable(GL_LINE_SMOOTH);
    ::glEnable(GL_POINT_SMOOTH);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
//    ReadPNMTexture("man.pnm",
    ReadPNMTexture("notations.pnm",        
                   m_texName, m_texWidth,m_texHeight);
    
    //    ReadPPM_SetTexture("checkerboard.ppm");    
    //    std::cout << m_texName << std::endl;
    glEnable(GL_TEXTURE_2D);
    //	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    //	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    
    float tex_border_Color[4] = { 1,1,1,0 };
    glTexParameterfv( GL_TEXTURE_2D, GL_TEXTURE_BORDER_COLOR, tex_border_Color );
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);        
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);    
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);    
  }  
  
  
  
  // Suggestion window
  ::glutInitWindowPosition(910,100);
  ::glutInitWindowSize(300,600);
  ::glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
  iwin_sgg = glutCreateWindow("Suggestion Window");
  ::glutMotionFunc(myGlutMotion);
	::glutMouseFunc(myGlutMouse);
	::glutDisplayFunc(myGlutDisplay);
	::glutReshapeFunc(myGlutResize);
	::glutKeyboardFunc(myGlutKeyboard);
  ::glutSpecialFunc(myGlutSpecialFunc);
	::glutIdleFunc(myGlutIdle);  
  ::glutPassiveMotionFunc(myGlutPassiveMotion);
  {
    ::glutSetWindow(iwin_sgg);    
    ////
    ::glEnable(GL_LIGHTING);
    ::glEnable(GL_LIGHT0);            
    float light0pos[4] = {0,10,+20,0};
    ::glLightfv(GL_LIGHT0, GL_POSITION, light0pos);      
    float white[3] = {0.8,0.8,0.8};
    ::glLightfv(GL_LIGHT0, GL_DIFFUSE, white);
    
    ::glEnable(GL_LIGHT1);    
    float light1pos[4] = {3,10,+10,0}; 
    ::glLightfv(GL_LIGHT1, GL_POSITION, light1pos);          
    float white2[3] = {0.4,0.4,0.4};
    ::glLightfv(GL_LIGHT1, GL_DIFFUSE, white2);        
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
  }  
  
  camera_des.SetRotation2DH(30*3.1415/180.0, 20*3.1415/180.0);
  SetNewProblem();  
  {
    bool res = jrb.loadFile("example0.dat");
//    bool res = jrb.loadFile("shelf4.dat");    
    if( res ){
      isgg_hover = -1;
      aSggJRB.clear();
      aDesModeBound.clear();
    }
    if( jrb.aRI.size() == 0 ){
      Com::CBoundingBox3D bb(-0.3,0.3, -0.3,0.3, -0.3,0.3);
      camera_des.Fit(bb);
    }
    else{
      camera_des.Fit(jrb.GetBoundingBox(false));    
    }
    ::glutSetWindow(iwin_des);  
    ::glMatrixMode(GL_PROJECTION);
    ::glLoadIdentity();
    Com::View::SetProjectionTransform(camera_des);                
  }      
  
  is_animation = true;
  
  ::glutMainLoop();

	// Enter main loop
	::glutMainLoop();
	return 0;
}
