/*
 *  optimize_furniture.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 11/6/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

class CDesModeBound
{
public:
  CDesignSensitivity desMode;
  double tmin, tmax;
  ////
  int irb0; 
  int imode0; // 0-8
  double r0;
  ////
  int irb1;
  int imode1; // 0-8
  double r1;
  ////
  int irb2;
  int imode2; // 0-8
  double r2;  
};


void Optimize_GradModes
(double alpha,
 std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,                                        
 std::vector<CJoint_Fix>& aFix, 
 std::vector<CJoint_Fix_Force>& aJFixForce,
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 const std::vector<CExternalForceOnRigidBody>& aMyExForce,     
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);

void GetBendingInvariantModes
(std::vector<CDesignSensitivity>& aDesMode,
 const std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,                                        
 const std::vector<CJoint_Fix>& aFix, 
 std::vector<CJoint_Fix_Force>& aJFixForce,
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 const std::vector<CExternalForceOnRigidBody>& aExForce,     
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);

void GetSuggestionModes_JointDurable
(std::vector<CDesModeBound>& aDesModeBound,
 const std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,                                        
 const std::vector<CJoint_Fix>& aFix, 
 std::vector<CJoint_Fix_Force>& aJFixForce,
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 const std::vector<CNailJoint>& aNailJoint,
 const std::vector<CExternalForceOnRigidBody>& aExForce,  
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);

void GetSuggestionModes_TopplingStable
(std::vector<CDesModeBound>& aDesModeBound,
 const std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,                                        
 const std::vector<CJoint_Fix>& aFix, 
 std::vector<CJoint_Fix_Force>& aJFixForce,
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 const std::vector<CNailJoint>& aNailJoint,
 const std::vector<CExternalForceOnRigidBody>& aExForce,  
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);


void PrintOutForceSpace
(std::vector<CRigid3D_Ini>& aRI, 
 std::vector<CRigid3D_Def>& aRD,                                        
 std::vector<CJoint_Fix>& aFix, 
 std::vector<CJoint_Fix_Force>& aJFixForce,
 const std::vector< std::pair<unsigned int, unsigned int> >& aFixDir,
 std::vector<CNailJoint>& aNailJoint,
 const std::vector<CExternalForceOnRigidBody>& aExForce,  
 ////
 const Com::CVector3D& gravity,
 const CContactProp& contProp,
 std::vector<CContactPoints_RigidBody3D>& aFP);

