/*
 *  rigid_contact_ls.h
 *  rigid3d
 *
 *  Created by Nobuyuki Umetani on 9/24/11.
 *  Copyright 2011 The University of Tokyo. All rights reserved.
 *
 */

#if !defined(RIGID_CONTACT_LS_H)
#define RIGID_CONTACT_LS_H

#include "rigidbody.h"

#include "rigid_contact.h"
#include "furniture_utility.h"

/*
void AddContact_NewmarkBetaAPrime
(const CRigidBody3D& rb,
 Ls::CLinearSystem_RigidBody& ls, unsigned int irb,
 const double dt, const double newmark_gamma, const double newmark_beta,
 bool is_initial,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double cont_stiff);
 */

/*
void AddContact_BackwardEular
(const CRigidBody3D& rb,
 Ls::CLinearSystem_RigidBody& ls, unsigned int irb,
 const double dt, 
 bool is_initial,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double cont_stiff);
*/
/*
 void AddLinearSystem_StaticContact
 (unsigned int irb, const CRigidBody3D& rb,
 Ls::CLinearSystem_RigidBody& ls,
 PARAM_TYPE itype_s, int irb_s, unsigned int idim_s,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const std::vector<CFrictionPoint>& aFP);
 */

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void AddLinSys_FrictionalContact_Penalty_NonStatic_BackwardEular
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,    
 Com::CVector3D& a, double dt,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f, double myu_s, double myu_k,
 CFrictionPoint& fp );

void AddLinSys_FrictionalContact_Penalty_NonStatic_BackwardEular_Contact
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,   
 Com::CVector3D& a, double dt,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f, 
 const CFrictionPoint& fp );

void AddLinSys_FrictionalContact_Penalty_Static_Contact
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,    
 Com::CVector3D& a, 
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f,
 const CFrictionPoint& fp);

void AddLinearSystem_RigidBody_BackwardEular
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,     
 const double dt, 
 const Com::CVector3D& gravity, 
 bool is_initial);


/*
void AddContact_BackwardEular
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigidBody3D& rb,
 const double dt, 
 bool is_initial,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f, double myu_s, double myu_k, 
 CContactPoints_RigidBody3D& aFP );
*/

void AddLinearSystem_ExternalForce_BackwardEular
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,  
 const double dt, 
 bool is_initial,
 const Com::CVector3D& pos, const Com::CVector3D& force);

void AddLinearSystem_ExternalForce_Static
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,  
 const Com::CVector3D& pos, const Com::CVector3D& force);

/*
void AddContact_BackwardEular_IntactContactState
(MatVec::CMatDia_BlkCrs& mat, MatVec::CVector_Blk& r,
 unsigned int irb, const CRigidBody3D& rb,
 const double dt, 
 bool is_initial,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f, 
 const CContactPoints_RigidBody3D& aCP );
*/
void UpdateSolution_RigidBody_BackwardEular
(CRigidBody3D& rb, 
 const double* upd, 
 double dt,
 bool is_first_iter );

///////////////////////////////////////////////////////////////////////////

void AddResidual_StaticContact
(const Com::CVector3D& d, const Com::CMatrix3& Q, 
 const Com::CVector3D& u, const Com::CMatrix3& P,
 const Com::CVector3D& a,
 unsigned int irb,
 std::vector< std::pair<Com::CVector3D,Com::CVector3D> >& aResPR,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const CFrictionPoint& aFP);

void Update_FrictionalContact
(const Com::CVector3D& d, const Com::CMatrix3& Q, 
 const Com::CVector3D& u, const Com::CMatrix3& P,
 const Com::CVector3D& v, const Com::CVector3D& O,   
 Com::CVector3D& v0,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm,
 double stiff_n, double stiff_f, double myu_s, double myu_k,
 CFrictionPoint& fp );

void UpdateContact_RigidBody
(const CRigid3D_Ini& ri, const CRigid3D_Def& rd,     
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, 
 double stiff_n, double stiff_f, double myu_s, double myu_k, 
 CContactPoints_RigidBody3D& aFP );

// get sensitivity of current poisition on rigid body(irb) according to "sns_pr"
// if (irb==irb_s) constider initial configuration change (itype_s,iobj_s,idim_s)
Com::CVector3D GetSensitivityCurrentPointOnRigidBody
(PARAM_TYPE itype_s, unsigned int irb_s, unsigned int idim_s,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,   
 unsigned int i, 
 const CContactPoints_RigidBody3D& aCP, 
 const std::pair< Com::CVector3D, Com::CVector3D>& sns_prlm );

Com::CVector3D GetSensitivityCurrentPointOnRigidBody
(const Com::CVector3D& sD,
 const Com::CVector3D& sQ,
 const Com::CVector3D& sL,
 const Com::CVector3D& sU, 
 const Com::CVector3D& sP, 
 const CRigid3D_Ini& ri, const CRigid3D_Def& rd,   
 const Com::CVector3D& v0,
 const Com::CMatrix3& B0 );

void GetSensitivityInitialPointOnRigidBody
(const CRigid3D_Ini& ri,
 unsigned int i, 
 const CContactPoints_RigidBody3D& aCP, 
 Com::CMatrix3& sns_p, 
 Com::CMatrix3& sns_r,
 Com::CMatrix3& sns_l );

void GetSensitivityInitialPointOnRigidBody
(Com::CMatrix3& sns_p, 
 Com::CMatrix3& sns_r,
 Com::CMatrix3& sns_l,
 const CRigid3D_Ini& ri, 
 const Com::CVector3D& v0, 
 const Com::CMatrix3& B0);


///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

enum ANCHOR_RELOCATION_TYPE{DONT_MOVE,MOVE_TOGETHER,MOVE_INITIAL};

void AddSensitivityResidual_StaticContact
(unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd, 
 Com::CMatrix3& ResP,Com::CMatrix3& ResR,  
 PARAM_TYPE itype_s, int irb_s, 
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const CContactPoints_RigidBody3D& aCP,
 ANCHOR_RELOCATION_TYPE itype_anchor_reloc);

void AddMatrix_StaticContact_Sensitivity
(MatVec::CMatDia_BlkCrs& m_mat, 
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,  
 PARAM_TYPE itype_s, int irb_s, unsigned int idim_s,
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const CContactPoints_RigidBody3D& aFP,
 ANCHOR_RELOCATION_TYPE itype_anchor_relocation);
/*
void AddMatrix_StaticContact_Sensitivity_AnchorInitial
(MatVec::CMatDia_BlkCrs& m_mat, 
 unsigned int irb, const CRigidBody3D& rb,  
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const CContactPoints_RigidBody3D& aFP,
 ANCHOR_RELOCATION_TYPE itype_anchor_relocation);
*/
void AddMatrix_StaticContact
(MatVec::CMatDia_BlkCrs& m_mat, 
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd,  
 const Com::CVector3D& cont_base, const Com::CVector3D& cont_norm, double stiff_n, double stiff_f,
 const CContactPoints_RigidBody3D& aCP);

void AddResidual_ExternalForce_Static
(Com::CVector3D& res_v, Com::CVector3D& res_r,
 const CRigid3D_Ini& ri, const CRigid3D_Def& rd,  
 const Com::CVector3D& pos, const Com::CVector3D& force);

void AddMatrix_ExternalForce_Static
(MatVec::CMatDia_BlkCrs& mat,
 unsigned int irb, const CRigid3D_Ini& ri, const CRigid3D_Def& rd, 
 const Com::CVector3D& pos, const Com::CVector3D& force);

/*
void UpdateAnchorRigidBody
(std::vector<CFrictionPoint>& aFP,
 const CRigidBody3D& rb0,
 PARAM_TYPE itype_s,unsigned int irb_s, unsigned int idim_s,
 double eps,
 const Com::CVector3D& n0);
*/

#endif